#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import verwaltungmysql
import sortieren
import types
import os
import gemeindekarteiweb
import gemeindekarteimysql
import optionen

primaerkartei = 'LfdNummer'
tabuschluessel = [primaerkartei,'LetzteAenderung']


class Abkuerzungen(verwaltungmysql.MySQLZugriff):
    
    def __init__(self,MysqlDatenbank,buchungsjahr,gemeindekartei=None,datenbank="dummy",tabelle="abkuerzungen"):
        self.buchungsjahr = buchungsjahr
        verwaltungmysql.MySQLZugriff.__init__(self,MysqlDatenbank,datenbank=datenbank,tabelle=tabelle)
        self.gemeindekartei = gemeindekartei
        self.optionen = optionen.Optionen(MysqlDatenbank,self.buchungsjahr)

    def primaerschluessel(self):
        return primaerkartei

    def alleAbkuerzungenGemeindekartei(self):
        return self.optionen.alleAbkuerzungenGemeindekartei()

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",defaultsuche="nein",sortierkategorie="Abkuerzung"):
        if defaultsuche == "ja":
            # ggf. zu implementieren
            pass
        return verwaltungmysql.MySQLZugriff.eintragSuchfunktion(self,suchdict=suchdict,datumumwandeln=datumumwandeln,sortierkategorie=sortierkategorie)

    def abkuerzungBedeutung(self,abkuerzung):
        dict = self.eintragSuchfunktion({"Abkuerzung": abkuerzung})
        try:
            return dict[0]["Bedeutung"]
        except:
            return abkuerzung

    def neuerEintrag(self,neudict,primaerdummy=primaerkartei,schluesselwert=None,tabelle=None):
        """berschreibt die Funktion in der bergeordneten Klasse MySQLZugriff.
        Erzeugung des neuen Schlssels per auto_increment."""
        abkuerzung = neudict.get("Abkuerzung","-")
        if not self.abkuerzungNichtVorhanden(abkuerzung,"Neueintrag nicht mglich!"):
            return 0
        if tabelle is None:
            tabelle = self.Tabellenname
        primaerdummy = primaerkartei
        uebergabedict = self.leererEintrag
        uebergabedict.update(neudict)
        uebergabedict = self.tabuschluesselEntfernen(uebergabedict,tabuschluessel)
        self.neuerEintragDirekt(uebergabedict)
        neuerSchluessel = self.letzterAutoEintrag()
        return neuerSchluessel

    def eintragLoeschen(self,primaerdummy=primaerkartei,schluesselwert=None):
        """berschreibt die gleichnamige Funktion aus MySQLZugriff"""
        primaerdummy=primaerkartei # s.oben
        temp = self.schluesselSuchen(schluesselwert)[0]
        if not temp:
            print "Schluessel %s nicht gefunden - Loeschen nicht moeglich!" % schluesselwert
            return 0 # Abbruch
        temp1 = self.inGemeindekartei(temp.get("Abkuerzung"))
        if not temp1:
            return verwaltungmysql.MySQLZugriff.eintragLoeschen(self,primaerdummy,schluesselwert)
        else:
            print "Die Abkrzung \"%s\" wird in der Gemeindekartei bereits benutzt - Lschen nicht mglich!" % temp["Abkuerzung"]
            return 0
            

    def eintragVergleichen(self,schluessel,vergleichdict,nichtvergleichen=tabuschluessel):
        vergleichdictvollstaendig = self.leererEintrag
        vergleichdictvollstaendig.update(vergleichdict)
        # wichtig, wenn in vergleichdict bestimmte Eintrge fehlen,
        # die z.B. in einem Eingabeformular von "Name" auf "" gesetzt wurden.
        # Sie wrden sonst nicht verglichen (vgl. die Superklasse).
        return verwaltungmysql.MySQLZugriff.eintragVergleichen(self,{primaerkartei:schluessel},vergleichdictvollstaendig,nichtvergleichen=nichtvergleichen)

    def schluesselSuchen(self,schluessel,defaultsuche="nein"):
        return self.eintragSuchfunktion({primaerkartei: schluessel},defaultsuche=defaultsuche) 

    def serienbriefVerzeichnis(self,verzeichnis,user):
        return os.path.join(verzeichnis,"User_%s" % user)

    def abkuerzungNichtVorhanden(self,abkuerzung,fehlermeldung):
        if abkuerzung == "-":
            # Leere Eintrge sollen keine Fehlermeldung bringen:
            return 1
        try:
            if self.wertVorhanden("Abkuerzung",abkuerzung):
                print "Die Abkrzung \"%s\" existiert schon - %s" % (abkuerzung,fehlermeldung)
                return 0
            # Achtung, Test:
            # Die folgenden Prfungen wurden abgeschaltet. Kombinationen von Abkrzungen sollten nicht mehr
            # mit Wildcards, sondern mit der neuen "ODER"-Abfrage gesucht werden. => Nein - nicht gut, auch nicht
            # mit den neuen Abfragen!
            if self.wertVorhanden("Abkuerzung","%"+abkuerzung+"%"):
                print "Die Abkrzung \"%s\" ist schon in anderen Abkrzungen enthalten. \nBitte erweitern, damit eindeutig!" % abkuerzung
                print "%s" % fehlermeldung
                return 0
            for wert in self.werteListe("Abkuerzung"):
                if abkuerzung.find(wert) != -1:
                    print "Die Abkrzung \"%s\" ist schon in der neuen Abkrzung \"%s\" enthalten!\nBitte verndern, damit eindeutig!" % (wert,abkuerzung)
                    print "%s" % fehlermeldung
                    return 0
            if len(abkuerzung) < 2:
                print "Abkrzungen mssen aus mindestens 2 Zeichen bestehen - %s" % fehlermeldung
                return 0
            else:
                return 1        
        except:
            return 1
        
    
    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel=""):
        # Parameter "primaerschluessel" nur aus Kompatibilitt, damit die Schnittstelle
        # noch 4 Parameter hat.        
        aenderungsdict = self.tabuschluesselEntfernen(aenderungsdict,tabuschluessel)
        neue_abkuerzung = aenderungsdict.get("Abkuerzung","-")
        alte_abkuerzung = self.schluesselSuchen(schluessel)[0]["Abkuerzung"]
        if not self.abkuerzungNichtVorhanden(neue_abkuerzung,"nderung nicht mglich!"):
            return 0
        if self.inGemeindekartei(alte_abkuerzung):
            print "Abkrzung in Gemeindekartei schon benutzt - nderung nicht mglich!"
            aenderungsdict = self.tabuschluesselEntfernen(aenderungsdict,["Abkuerzung"])
        try:
            verwaltungmysql.MySQLZugriff.eintragAendern(self,aenderungsdict,primaerkartei,schluessel)
        except:
            # Ein bler Patch, weil anscheinend manche Browser - wenn man Neueintrge mit Sonderzeichen macht -
            # von einer "warning" des MysqlDB-Pakets berrascht werden (z.B. Konqueror-Browser. Nicht Netscape)
            # Mit dem Patch geht es.
            pass
        
    def sortierteListe(self,sortierkategorie,spaltenliste=None,rueckgabe="dictionary"):
        where = ""
        return verwaltungmysql.MySQLZugriff.sortierteListe(self,sortierkategorie,spaltenliste,rueckgabe,where)   

    def inGemeindekartei(self,abkuerzung,sortierkategorie="Nachname"):
        try:
            kategorien = self.optionen.alleAbkuerzungenGemeindekartei()
            # in diesen Kategorien soll die Abkrzung vorkommen
            temp = self.gemeindekartei.oderListeAbfragenBestandteil(abkuerzung,kategorien=kategorien,sortierkategorie=sortierkategorie)
            if temp[0]:
                return temp
            else:
                # ein leeres Tupel als einziger Fund:
                return 0
        except:
            return 0
   
        
        

        
        
