#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import verwaltungmysql
import sortieren
import types
import os
import gemeindekarteiweb
import optionen
import abkuerzungenmysql
import glob
import shutil
import time
import verschiedeneUtilities
import verwaltungMainServer
#import zuordnungenmysql

datumsform = re.compile(r"\d\d\d\d-\d\d-\d\d")
#kirchenbuchform = re.compile(r"K[AG]\d\d\d")
heute = datumutilities.Datum()
primaerkartei = 'MZ'
tabuschluessel = [primaerkartei,'LetzteAenderung','BearbeitetVon']
# backupdatei = "/windowsc/Martin/verwalt/Gemeindekartei/bezirksreitergemeindekartei.txt"
if sys.platform[:3]=="win":
    backupdatei = r"c:\Martin\verwalt\Gemeindekartei\bezirksreitergemeindekartei.txt"
    # anderer Pfad fr Windows

Benutzername = ""
User = ""
# wird von verwaltungMainServer gesetzt

class GemeindekarteiNormal(verwaltungmysql.MySQLZugriff):
    global primaerkartei,tabuschluessel,Benutzername

    def __init__(self,MysqlDatenbank, buchungsjahr,datenbank="dummy",tabelle="gemeindekartei"):
        self.buchungsjahr = buchungsjahr
        verwaltungmysql.MySQLZugriff.__init__(self,MysqlDatenbank,datenbank,tabelle)
        self.optionen = optionen.Optionen(MysqlDatenbank,self.buchungsjahr)
        self.abkuerzungen = abkuerzungenmysql.Abkuerzungen(MysqlDatenbank,self.buchungsjahr)
        # self.baukonto = baukontomysql.Baukonto(MysqlDatenbank,self.buchungsjahr) => Nein: Achtung, zyklische Initialisierungen!
        # Die Klasse Baukonto enthlt bereits eine Gemeindekartei-Instanz!

    def primaerschluessel(self):
        return primaerkartei

    def abkuerzungsListe(self):
        """Gibt eine Liste aller definierten Abkrzungen fr die Gemeindekartei."""
        dictarray = self.abkuerzungen.sortierteListe("Abkuerzung")
        try:
            return [i["Abkuerzung"] for i in dictarray]
        except:
            return []
                

    def abkuerzungBedeutung(self,abkuerzung,format="text",alleAbkuerzungen=[]):
        """bergeben wird ein Text, der mglicherweise mehrere Abkrzungen enthlt, z.B
        durch ";" getrennt."""
        if alleAbkuerzungen == []:
            alleAbkuerzungen = self.abkuerzungsListe()
        liste = self.Textwerkzeug.schluesselworteFinden(abkuerzung,alleAbkuerzungen)
        if liste == []:
            return abkuerzung # der reine Text zurck
        bedeutung_liste = [self.abkuerzungen.abkuerzungBedeutung(i) for i in liste]
        if format == "text":
            temptext = ""
            for i in bedeutung_liste:
                temptext += "%s, " % i
            return temptext[:-2] # "Schwanz" weg
        elif format == "liste":
            return bedeutung_liste

    def emailSenden(self,text,liste,subject="Nachricht",absender="test@test"):
        smtp_server= self.optionen.optionen["EMailServer"]
        return verwaltungmysql.MySQLZugriff.emailSenden(self,text=text,liste=liste,smtp_server=smtp_server,subject=subject,absender=absender)        

    def abkuerzungenPruefen(self,dict,alleAbkuerzungen=[]):
        """Prft auf korrekte Anwendung von Abkrzungen, vgl. Abk_Gemeindekartei
        in Optionen."""
        # Achtung, Test:        
        flag = 1
        abkuerzungen = self.abkuerzungen.werteListe("Abkuerzung",distinct="ja")
        if alleAbkuerzungen == []:
            alleAbkuerzungen = self.optionen.alleAbkuerzungenGemeindekartei()
        for kategorie in alleAbkuerzungen:
            temp = self.Textwerkzeug.abkuerzungenTesten(dict.get(kategorie,"-"),abkuerzungen)
            if temp["TestText"] != "-" and temp["TestText"] != "":
                print "Ungltige Abkrzung(en) in Kategorie %s!" % kategorie
                print "Falscher Datensatz: %s" % dict
                flag = 0
        return flag

    def spendername(self,schluessel,alleDaten="nein"):
        rueckdict = {}
        tempdict = self.schluesselSuchen(schluessel)[0]
        try:
            vorname,nachname = tempdict["Vorname"],tempdict["Nachname"]
            if vorname == "-" and nachname == "-":
                raise ValueError # weiter nach unten...
            if alleDaten == "ja":
                rueckdict.update(tempdict)
                # so werden alle Daten bertragen. Das kann zu Verwirrungen fhren:
                # beispielsweise enthlt auch ein Buchungssatz eine Kategorie "Bemerkungen".
            rueckdict["Spendername"] = "%s, %s" % (nachname,vorname)
            rueckdict["MZ"] = "%s" % tempdict["MZ"]
            # wir brauchen einen String fr die MZ.
        except:
            rueckdict["Spendername"] = "-"
            rueckdict["MZ"] = "0"
        return rueckdict

    def anredeAllgemein(self,geschlecht,form):
        anrededict = {"AnredeFoermlich": ("Frau","Herrn"),
                      "Foermlich": ("Frau","Herr"),
                      "PronomenKlein": ("sie","er"),
                      "GemeindeLang": ("Schwester","Bruder"),
                      "GemeindeKurz": ("Schw.","Brd."),
                      "Brief": ("Liebe","Lieber"),
                      "BriefFoermlich": ("Sehr geehrte Frau", "Sehr geehrter Herr")}
        if geschlecht == "wl":
            return anrededict[form][0]
        elif geschlecht == "ml":
            return anrededict[form][1]
        else:
            return ""   

    def sicherungsdatei(self):
        return backupdatei

    def eintragPruefen(self,pruefdict):
        nichtleer = ["Geburtstag","Zugangsdatum","Zugangsgrund","Familienstand", "Nachname","Vorname"]
        for i in nichtleer:
            test = pruefdict.get(i,"")
            #print "%s: %s" % (i,test)
            if (not test) or (test=="0000-00-00") or (test=="-"):
                print "Achtung, Feld %s ist leer!" % i
        if pruefdict["abgegangen"] == "ja" and pruefdict["Abgangsdatum"] == "0000-00-00":
            print "Die Abgangseintrge sind nicht konsistent!"
        if pruefdict["abgegangen"] == "nein" and pruefdict["Abgangsdatum"] != "0000-00-00":
            print "Die Abgangseintrge sind nicht konsistent!"
        if pruefdict["Status"][:7] == "Kirchen" and pruefdict["Kirchenbuch"] == "-":
            print "Achtung, Kirchenbuchnummer fehlt!"
        try:            
            zugangsdatum = pruefdict["Zugangsdatum"]
            abgangsdatum = pruefdict["Abgangsdatum"]
            if (zugangsdatum >= abgangsdatum) and abgangsdatum != "0000-00-00":
                # Zugangsdatum und Abgangsdatum sind in der Datenbank als "Date"-Felder gespeichert.
                print "Achtung, Zugangsdatum und Abgangsdatum sind gleich oder Zugangsdatum spter als Abgangsdatum!"
        except:
            pass

    def abgaengeSuchen(self,status,grund,jahr=None):
        if jahr is None:
            jahr = self.buchungsjahr
        suchdict = {"Abgangsdatum": "%s-??-??" % jahr, "Abgangsgrund": grund,"Status": status}
        return self.eintragSuchfunktion(suchdict)

    def zugaengeSuchen(self,status,grund,jahr=None):
        if jahr is None:
            jahr = self.buchungsjahr
        suchdict = {"Zugangsdatum": "%s-??-??" % jahr, "Zugangsgrund": grund,"Status": status}
        return self.eintragSuchfunktion(suchdict)

    def alleZugaenge(self,jahr=None):
        if jahr is None:
            jahr = self.buchungsjahr
        gesamtdict = {}
        for status in (self.optionen.gemeindekartei_optionsfelder())["Status"]:
            statusdict = {}
            for grund in (self.optionen.gemeindekartei_optionsfelder())["Zugangsgrund"]:
                tempdictarray = self.zugaengeSuchen(status,grund)
                if not tempdictarray[0]:
                    # Leereintrge sollen nicht mit der Lnge 1 gezhlt werden.
                    laenge = "-"
                else:
                    laenge = "%s" % len(tempdictarray)
                statusdict[grund] = {"Datenstze": tempdictarray,"Lnge": laenge}
            gesamtdict[status] = statusdict
        return gesamtdict


    def alleAbgaenge(self,jahr=None):
        if jahr is None:
            jahr = self.buchungsjahr
        gesamtdict = {}
        for status in (self.optionen.gemeindekartei_optionsfelder())["Status"]:
            statusdict = {}
            for grund in (self.optionen.gemeindekartei_optionsfelder())["Abgangsgrund"]:
                tempdictarray = self.abgaengeSuchen(status,grund)
                if not tempdictarray[0]:
                    laenge = "-"
                else:
                    laenge = "%s" % len(tempdictarray)
                statusdict[grund] = {"Datenstze": tempdictarray,"Lnge": laenge}
            gesamtdict[status] = statusdict
        return gesamtdict

    def statusUebersicht(self):
        rueckgabe = {}
        for status in (self.optionen.gemeindekartei_optionsfelder())["Status"]:
            befehl = """select count(MZ) from gemeindekartei where Status like "%s" and abgegangen like "nein" """ % status
            self.Cursor.execute(befehl)
            rueckgabe[status] = self.Cursor.fetchall()[0][0]
        return rueckgabe
        

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",defaultsuche="nein",sortierkategorie="Nachname",abkuerzungen=[],abk_liste=[]):
        # bei defaultsuche="ja" werden nur nicht abgegangene Glieder und
        # Angehrige gesucht
        if abk_liste == []:
            abk_liste = self.abkuerzungen.werteListe("Abkuerzung",distinct="ja")
        if abkuerzungen == []:
            abkuerzungen = self.optionen.alleAbkuerzungenGemeindekartei()
        if abkuerzungen != ["-"]:
            # wenn das Feld nicht leer ist.
            for feld_mit_abkuerzungen in abkuerzungen:
                # intuitive Suche nach Abkrzungen, wenn nur ein einziges Krzel
                # ohne alles eingegeben wird, und dieses Krzel in der Liste der Abkrzungen vorkommt.
                try:
                    feldwert = suchdict.get(feld_mit_abkuerzungen,"")
                    if (feldwert.find("*") == -1) and (feldwert.find("?") == -1) and (feldwert.find("NEIN") == -1) and (feldwert.find("JA") == -1):
                        # Keine Suche nach leeren Eintrgen?
                        # Keine Wildcards im Suchstring? Wenn man doch mit Wildcards przise suchen will, geht das aber.
                        if feldwert.find("ODER") != -1:
                            # *** Behandlung der ODER-Abfrage *****
                            liste = feldwert.split("ODER")
                            liste = [string.strip(i) for i in liste]
                            for oder_feldwert in liste:
                                if oder_feldwert not in abk_liste:
                                    print """Die Abkrzung "%s" ist nicht in der Liste der Abkrzungen oder sie wurde falsch geschrieben!""" % oder_feldwert
                                    suchdict[feld_mit_abkuerzungen] = "xxxxxxxxxxxxyxxxxxxxxxxxx"
                                else:
                                    # Es knnen mehrere Abkrzungen eingetragen sein, deswegen die Hinzufgung von "*":
                                    suchdict[feld_mit_abkuerzungen] = suchdict[feld_mit_abkuerzungen].replace(oder_feldwert,"*"+oder_feldwert+"*")                                
                            # *** Ende der ODER-Abfrage *****
                        elif feldwert and (feldwert not in abk_liste):
                            # falsche Abkrzungen werden nicht bercksichtigt, leere Eingabefelder aber nicht als
                            # falsch gemeldet:
                            print """Die Abkrzung "%s" ist nicht in der Liste der Abkrzungen oder sie wurde falsch geschrieben!""" % feldwert
                            suchdict[feld_mit_abkuerzungen] = "xxxxxxxxxxxxyxxxxxxxxxxxx"
                            # ein Dummy-Wert, der eine "nicht gefunden"-Meldung produziert.
                        else:
                            suchdict[feld_mit_abkuerzungen] = "*%s*" % feldwert
                except:
                    pass
        if defaultsuche == "ja":
            # Das "ja" mu ggf. in Subklassen berschrieben werden, z.B. fr emkadressen
            suchdict["Status"] = "Kirchen*"
            suchdict["abgegangen"] = "nein"
        return verwaltungmysql.MySQLZugriff.eintragSuchfunktion(self,suchdict=suchdict,datumumwandeln=datumumwandeln,sortierkategorie=sortierkategorie)

    def wformat(self,string):
        """Umwandlung in Whrungsformat mit zwei Nachkommastellen. Gibt es so hnlich auch in baukontoweb und baukontomysql."""
        try:
            string = "%.2f" % round(float(string),2)
            if string == "0.00":
                return "-"
            else:
                return string
        except:
            return string

    def neuerEintrag(self,neudict,primaerdummy=primaerkartei,schluesselwert=None,tabelle=None,protokoll="ja",alleAbkuerzungen=[],tabuneu=tabuschluessel):
        """berschreibt die Funktion in der bergeordneten Klasse MySQLZugriff.
        Erzeugung des neuen Schlssels per auto_increment."""
        if tabelle is None:
            tabelle = self.Tabellenname
        #primaerdummy = primaerkartei
        uebergabedict = self.leererEintrag
        uebergabedict.update(neudict)
        uebergabedict = self.tabuschluesselEntfernen(uebergabedict,tabuneu)
        if uebergabedict.has_key("abgegangen"):
            del uebergabedict['abgegangen']
        if not self.abkuerzungenPruefen(dict=uebergabedict,alleAbkuerzungen=alleAbkuerzungen):
            return 0
        # ***** keine eigene MZ, abgegangen per default = "nein" in Datenbank!
        uebergabedict["BearbeitetVon"] = Benutzername
        self.neuerEintragDirekt(uebergabedict)
        neuerSchluessel = self.letzterAutoEintrag()
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll == "ja":
            self.emailProtokoll(self.neuerEintragProtokoll(neuerSchluessel,uebergabedict),Benutzername)
        return neuerSchluessel

    def neuerEintragProtokoll(self,schluessel,dict):
        #datensatz = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: Anlegen eines neuen Datensatzes\nDatensatz: %s, %s (MZ=%s)\n\nNeue Daten:\n" % (Benutzername,dict["Nachname"],dict["Vorname"],schluessel)
        for i in dict.keys():
            text += "%s: %s\n" % (i,dict[i])
        return text

    def eintragLoeschen(self,primaerdummy=primaerkartei,schluesselwert=None,protokoll="ja"):
        """berschreibt die gleichnamige Funktion aus MySQLZugriff"""
        #primaerdummy=primaerkartei # Achtung, weglassen: Kommt sonst in Konflikt mit Subklassen.
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll=="ja":
            self.emailProtokoll(self.eintragLoeschenProtokoll(schluesselwert),Benutzername)
        return verwaltungmysql.MySQLZugriff.eintragLoeschen(self,primaerdummy,schluesselwert)

    def loginProtokoll(self,User):
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname):
            self.emailProtokoll("Login durch Benutzer %s\n\n" % User,User,nurAdmin="ja")

    def eintragLoeschenProtokoll(self,schluessel):
        dict = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: Lschen eines Datensatzes\nDatensatz: %s, %s (MZ=%s)\n\nNeue Daten:\n" % (Benutzername,dict["Nachname"],dict["Vorname"],schluessel)
        for i in dict.keys():
            text += "%s: %s\n" % (i,dict[i])
        return text            

    def eintragVergleichen(self,schluessel,vergleichdict,nichtvergleichen=tabuschluessel,kategorie=primaerkartei):
        vergleichdictvollstaendig = self.leererEintrag
        vergleichdictvollstaendig.update(vergleichdict)
        # wichtig, wenn in vergleichdict bestimmte Eintrge fehlen,
        # die z.B. in einem Eingabeformular von "Name" auf "" gesetzt wurden.
        # Sie wrden sonst nicht verglichen (vgl. die Superklasse).
        self.abkuerzungenPruefen(vergleichdictvollstaendig)
        self.eintragPruefen(vergleichdictvollstaendig)
        return verwaltungmysql.MySQLZugriff.eintragVergleichen(self,{kategorie:schluessel},vergleichdictvollstaendig,nichtvergleichen=nichtvergleichen)

    def schluesselSuchen(self,schluessel,defaultsuche="nein",eintrag_pruefen="nein",kategorie=primaerkartei):
        temp = self.eintragSuchfunktion({kategorie: schluessel},defaultsuche=defaultsuche)
        if eintrag_pruefen=="ja":
            self.eintragPruefen(temp[0])
        return temp

    def schluesselListeSuchen(self,schluesselliste,sortierkategorie="Nachname",zusatzbedingung="",rueckgabe="dictionary",primaerschluessel=primaerkartei):
        temp = None
        if not schluesselliste:
            return temp
        else:
            try:
                wherestring = """%s in %s""" % (primaerschluessel,self.listeAlsSQL(schluesselliste))
                wherestring += (" " + zusatzbedingung)
                if sortierkategorie is not None:
                    wherestring += """order by %s""" % sortierkategorie                    
                return self.eintragHolen(where=wherestring,rueckgabe=rueckgabe)
            except:
                return temp

    def emailListeSuchen(self,schluesselliste,sortierkategorie="Nachname",alsDictarray="ja"):
        # sucht aus einer MZ-Liste alle Eintrge mit bzw. ohne gltige E-Mail-Adresse.
        tempdictarray_email = self.schluesselListeSuchen(schluesselliste=schluesselliste,sortierkategorie=sortierkategorie,zusatzbedingung="""and EMail like "%@%" """)
        tempdictarray_noemail = self.schluesselListeSuchen(schluesselliste=schluesselliste,sortierkategorie=sortierkategorie,zusatzbedingung="""and EMail not like "%@%" """)
        if alsDictarray == "nein":
            return self.Sortierwerkzeug.listeAusDictarray(tempdictarray_email,"EMail"), self.Sortierwerkzeug.listeAusDictarray(tempdictarray_noemail,"EMail")
        else:
            return tempdictarray_email,tempdictarray_noemail

    def serienbriefSpendenUebersicht(self,vorlagentext,spendentabelle,openoffice):
        rueckgabe = vorlagentext
        try:
            webobjekt = gemeindekarteiweb.GemeindeverwaltungWeb(spendentabelle["Buchungstabelle"],"dummyzentrale",spendentabelle["Buchungstabelle"][0].keys())
        except:
            return vorlagentext
        # das webobjekt gebrauchen wir zur Formatierung der Datumsfelder.
        ersetzungen = ["Konto","Belegdatum","Betrag","Squittung_noetig"]
        maxanzahl = vorlagentext.count("TFA-%s-TFE" % ersetzungen[0])
        if maxanzahl < len(webobjekt.dictarray) and maxanzahl != 0:
            # wenn es eine bersichtsliste gibt - und nur dann (!=0) - wird gecheckt
            print "Die Anzahl der Spendenbuchungen ist grer als die Anzahl der maximal mglichen Spenden auf der Vorlage - Fehler!"
            return vorlagentext        
        for ersetzung in ersetzungen:
            ersetzungstext = "TFA-%s-TFE" % ersetzung
            if vorlagentext.count(ersetzungstext) != maxanzahl:
                print """Die Vorlage ist fr den Eintrag "%s" nicht konsistent - Fehler!""" % ersetzung
                return vorlagentext
            for buchung in webobjekt.dictarray:
                originaltext = buchung[ersetzung]
                if ersetzung == "Betrag":
                    originaltext = self.wformat("%s" % originaltext)
                    # ein scheulicher Patch, wegen der zwei Nachkommastellen. "wformat" kommt in drei verschiedenen
                    # Dateien vor (baukontomysql, baukontoweb, gemeindekarteimysql). Sollte man den Betrag
                    # nicht schon in baukontomysql formatieren?
                if not openoffice:
                    rueckgabe = rueckgabe.replace(ersetzungstext,originaltext,1) # nur die jeweils nchste ersetzen
                else:
                    rueckgabe = rueckgabe.replace(ersetzungstext,self.Textwerkzeug.openOfficeStringUtf8(originaltext),1)
            rueckgabe = rueckgabe.replace(ersetzungstext," ") # Leerstellen fr den Rest
        # Die "Spendensumme" ist getrennt zu behandeln:
        if not openoffice:
            rueckgabe = rueckgabe.replace("TFA-Spendensumme-TFE",spendentabelle["Spendensumme"]) 
            rueckgabe = rueckgabe.replace("TFA-Spendername-TFE",spendentabelle["Spenderdaten"]["Spendername"])
        else:
            rueckgabe = rueckgabe.replace("TFA-Spendensumme-TFE",self.Textwerkzeug.openOfficeStringUtf8(spendentabelle["Spendensumme"]))
            rueckgabe = rueckgabe.replace("TFA-Spendername-TFE",self.Textwerkzeug.openOfficeStringUtf8(spendentabelle["Spenderdaten"]["Spendername"]))
        # rueckgabe = rueckgabe.replace("TFA-Spendensumme-TFE",spendentabelle["Spendensumme"])
        return rueckgabe

    def serienbriefVerzeichnis(self,verzeichnis,user):
        return os.path.join(verzeichnis,"UserDir_%s" % user)

    def serienbriefHilfsdateienKopieren(self,verzeichnis,serienbriefverzeichnis):
        """Kopiert Hilfdateien - fr verlinkte Grafiken - aus dem Serienbriefverzeichnis
        in das User-Verzeichnis, damit sie dort zur Verfgung stehen."""
        grafikformate = ("eps","bmp","jpg","gif","tif","wmf","pcx","png")
        try:
            if self.win:
                os.chmod(serienbriefverzeichnis,0777)
                time.sleep(1) # fr Windows - verzgertes Setzen der Rechte
            alle = os.listdir(os.path.normpath(verzeichnis))
            for datei in alle:
                endung = datei[-3:].lower()
                if endung in grafikformate:
                    # alles, was nicht RTF-Datei ist...
                    quelle = os.path.normpath(os.path.join(verzeichnis,datei))
                    if not os.path.isfile(quelle):
                        continue # in der Liste ist auch das Verzeichnis selbst...
                    ziel = os.path.normpath(os.path.join(serienbriefverzeichnis,datei))
                    shutil.copyfile(quelle,ziel)
        except:
            print "Konnte verlinkte Grafiken nicht ins Serienbriefverzeichnis kopieren!"

    def serienbriefErstellen(self,user,verzeichnis,vorlage,schluesselliste,spendendict=None,privat_statt_dienstlich=1):
        """Erstellt aus einer Liste von MZs von einer Vorlage Serienbriefe,
        fr jeden Brief eine Datei, gespeichert im user-spezifischen Unterverzeichnis
        des Serienbriefverzeichnisses. Dazu mssen dort natrlich Schreibrechte bestehen.
        Funktioniert (wahrscheinlich) nur mit textbasierten Formaten wie RTF oder HTML usw.
        Neu: Erweiterung fr OpenOffice-sxw-Dateien.
        Der spendendict enthlt einen Dictionary, der - mit den MZs als Schlsseln - gefllt ist
        mit Objekten, die von baukonto.spendenTabelle erzeugt werden. Wird gebraucht fr Spendenquittungen."""
        # *** TODO: in die Superklasse, um ganz allgemein Formulare (z.B. fr die
        # *** Statistik) zu erzeugen.
        serienbriefverzeichnis = self.serienbriefVerzeichnis(verzeichnis,user)
        serienbriefdateinamen = []
        openoffice = 0
        openoffice_text = ""
        # Diesen Text brauchen wir, wenn wir alle Serienbriefe in eine Datei schreiben
        if vorlage.lower()[-3:] == "sxw":
            openoffice = 1
        if not os.path.exists(serienbriefverzeichnis):
            os.mkdir(serienbriefverzeichnis)
            # Achtung, die so erzeugten Verzeichnisse mssen irgendwann einmal "aufgerumt" werden.        
        for i in os.listdir(serienbriefverzeichnis):
            os.remove(os.path.join(serienbriefverzeichnis,i))
            # zuerst alte Serienbriefe lschen.
        self.serienbriefHilfsdateienKopieren(verzeichnis,serienbriefverzeichnis)
        vorlagenpfad = os.path.join(verzeichnis,vorlage)
        datei = open(vorlagenpfad,"rb")
        if not openoffice:
            vorlagentext = datei.read()
            datei.close()
        else:
            vorlagentext = self.Textwerkzeug.openOfficeLesen(datei)
        empfaengerliste = self.schluesselListeSuchen(schluesselliste)
        webobjekt = gemeindekarteiweb.GemeindeverwaltungWeb(empfaengerliste,"dummyzentrale",self.Spaltennamen)
        # das webobjekt gebrauchen wir zur Formatierung der Datumsfelder.
        besondereErsetzung = {"heute": heute.deutschesFormat(),
                              "Buchungsjahr": self.buchungsjahr,
                              "AnredeFoermlich": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"AnredeFoermlich"),
                              "GeschlechtFoermlich": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"Foermlich"),
                              "AnredePronomen": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"PronomenKlein"),
                              "AnredeGemeindeKurz": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"GemeindeKurz"),
                              "AnredeGemeindeLang": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"GemeindeLang"), 
                              "AnredeBrief": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"Brief"),
                              "AnredeBriefFoermlich": lambda x,self=self: self.anredeAllgemein(x["Geschlecht"],"BriefFoermlich")}
        # **** in diesem Dictionary stehen zustzliche Schlsselworte, die ersetzt werden:
        # **** z.B. das aktuelle Datum. Das kann noch erweitert werden.
        # **** Achtung bei Namensberschneidung mit den Kategorien!
        if privat_statt_dienstlich:
            webobjekt.dictarray = self.Textwerkzeug.privatStattDienstlichDictarray(webobjekt.dictarray) # fr emkadressen_neu
        for empfaenger in webobjekt.dictarray:
            temptext = vorlagentext
            for kategorie in self.Spaltennamen:
                tempreplace = "%s" % empfaenger[kategorie]
                if openoffice:
                    tempreplace = self.Textwerkzeug.openOfficeStringUtf8(tempreplace)
                temptext = temptext.replace("TFA-%s-TFE" % kategorie, tempreplace)
                # print temptext
            for besonders in besondereErsetzung.keys():
                ersetzung = besondereErsetzung[besonders]
                if callable(ersetzung):
                    # als Ersetzung eine Funktion des Empfngers bzw. seiner Kategorien:
                    tempreplace = ersetzung(empfaenger)
                else:
                    tempreplace = ersetzung
                if openoffice:
                    tempreplace = self.Textwerkzeug.openOfficeStringUtf8(tempreplace)
                temptext = temptext.replace("TFA-%s-TFE" % besonders,tempreplace)
            if spendendict is not None:
                temptext = self.serienbriefSpendenUebersicht(temptext,spendendict[empfaenger["MZ"]],openoffice)
            tempdatei = "%s%s" % (empfaenger["MZ"],vorlage)
            temppfad = os.path.normpath(os.path.join(serienbriefverzeichnis,tempdatei))
            if not openoffice:
                brief = open(temppfad,"wb")
                brief.write(temptext)
                brief.close()
                serienbriefdateinamen.append(temppfad)
            else:
                # Achtung, Test:
                # self.Textwerkzeug.openOfficeErsetzen(vorlagenpfad,temptext,temppfad)
                if openoffice_text != "":
                    openoffice_text = self.Textwerkzeug.openOfficeMerge(openoffice_text,temptext,pagebreak="ja")
                else:
                    openoffice_text = temptext
        if openoffice:
            serienbriefdateinamen.append(temppfad)
            # der letzte Empfnger wird pauschal fr den Dateinamen verwendet
            self.Textwerkzeug.openOfficeErsetzen(vorlagenpfad,openoffice_text,temppfad)
        # gibt die Pfad aller erstellten Serienbriefe als Liste zurck:
        return serienbriefdateinamen # wichtig z.B. fr automatisches ffnen bei EinzelDirekt

    def serienbriefAusdruckenOpenOffice(self,liste):
        gleichzeitig = self.optionen.druckAnzahl()
        # Soviele Dateien sollen OO gleichzeitig bergeben werden
        textverarbeitung = self.optionen.optionen["Textverarbeitung"]
        liste_aufgeteilt = []
        stringliste_teil = ""
        for index in range(len(liste)):
            if ((index+1) % gleichzeitig == 0) or (index == len(liste)-1):
                stringliste_teil += " %s" % liste[index]
                liste_aufgeteilt.append(stringliste_teil)
                stringliste_teil = ""
            else:
                stringliste_teil += " %s" % liste[index]
        for dateiliste_teil in liste_aufgeteilt:
            print dateiliste_teil
            befehl = """%s -p %s""" % (textverarbeitung,dateiliste_teil)
            #if not self.win:
            #    befehl += "&" # Start als eigener Proze bei Linux - sinnvoll?
            test = os.system(befehl)
            if test:
                return 0
        return 1

    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel="",protokoll="ja",tabu=tabuschluessel,abkuerzungen_pruefen="ja",altdict=None):
        # Parameter "primaerschluessel" nur aus Kompatibilitt, damit die Schnittstelle
        # noch 4 Parameter hat.
        # altdict ist optional - man kann ihn bergeben, z.B. wenn man eine andere schluesselSuchen-Funktion braucht.
        aenderungsdict = self.tabuschluesselEntfernen(aenderungsdict,tabu)
        aenderungsdict["BearbeitetVon"] = Benutzername
        if altdict is None:
            altdict = self.schluesselSuchen(schluessel)[0]
        if abkuerzungen_pruefen == "ja":
            if not self.abkuerzungenPruefen(aenderungsdict):
                return 0
        try:
            verwaltungmysql.MySQLZugriff.eintragAendern(self,aenderungsdict,primaerschluessel,schluessel)
        except:
            # Ein bler Patch, weil anscheinend manche Browser - wenn man Neueintrge mit Sonderzeichen macht -
            # von einer "warning" des MysqlDB-Pakets berrascht werden (z.B. Konqueror-Browser. Nicht Netscape)
            # Mit dem Patch geht es.
            pass
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll=="ja":
            self.emailProtokoll(self.eintragAendernProtokoll(altdict,aenderungsdict,schluessel),Benutzername)
        return 1

    def eintragAendernProtokoll(self,altdict,aenderungsdict,schluessel):
        datensatz = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: nderung eines Datensatzes\nDatensatz: %s, %s (MZ=%s)\n\nNeue Daten:\n" % (Benutzername,datensatz["Nachname"],datensatz["Vorname"],datensatz["MZ"])
        for i in aenderungsdict.keys():
            text += "%s: %s => %s\n" % (i,altdict[i],aenderungsdict[i])
        return text

    def tabelleExportierenCSV(self,user,verzeichnis,trenner="\t",sortierkategorie=primaerkartei,schluesselliste=None,mitUmwandlung="ja"):
        """berschreibt die entsprechende Funktion in der Superklasse. Ist die Funktion dort
        berhaupt ntig?"""
        if schluesselliste is not None:
             ganzetabelle = self.schluesselListeSuchen(schluesselliste=schluesselliste)
        else:
             ganzetabelle = self.sortierteListe(sortierkategorie,nurAktiveGlieder="nein")
        matrix = [self.Spaltennamen]
        serienbriefverzeichnis = self.serienbriefVerzeichnis(verzeichnis,user)
        dateiname = os.path.normpath(os.path.join(serienbriefverzeichnis,"Gemeindekartei_%s.txt" % self.Datenbankname))
        if mitUmwandlung == "ja":
            webobjekt = gemeindekarteiweb.GemeindeverwaltungWeb(ganzetabelle,"dummyzentrale",self.Spaltennamen)
            tempdictarray = webobjekt.dictarray
        else:
            tempdictarray = ganzetabelle        
        for eintrag in tempdictarray:
            tempmatrix = []
            for i in self.Spaltennamen:
                tempmatrix.append(eintrag[i])
            matrix.append(tempmatrix)
        if verwaltungMainServer.EINZELPLATZ_NEU == "ja":
            if not os.path.exists(serienbriefverzeichnis):
                os.mkdir(serienbriefverzeichnis)
                # Achtung, die so erzeugten Verzeichnisse mssen irgendwann einmal "aufgerumt" werden.
            # Achtung, Test:    #testprf
            test = self.Textwerkzeug.csvDateiSchreiben(matrix,dateiname,trenner)
            if test:
                return dateiname
            #    return "test" 
            else:
                return 0
        else:
            # fr Export ber Netzwerk:
            return self.Textwerkzeug.csvDateiSchreiben(matrix=matrix,dateiname=dateiname,trenner=trenner,alsString="ja")
        
       ## # Achtung, die MySQL-Anbindung gibt immer Tupel zurck, keine Listen!
##        # Deswegen eine neue Liste:
##        neuetabelle = [ ]
##        for i in range(0,len(ganzetabelle)):
##            neuetabelle.append(list(ganzetabelle[i]))
##            for j in range(0,len(neuetabelle[i])):
##                if self.Spaltennamen[j] != "Telefon":
##                    # Damit es bei Telefonnummern mit "-" kein
##                    # Durcheinander gibt.
##                    neuetabelle[i][j] = self.mysqlDatumUmwandeln(neuetabelle[i][j])
##        print neuetabelle
##        neuetabelle.insert(0,self.Spaltennamen)
        #print ganzetabelle
        # self.Textwerkzeug.csvDateiSchreiben(neuetabelle,dateiname)
        
    

    def geburtstageGemeindebrief(self,ab_alter=65,nur_aktive="ja",Anrede_verwenden="ja",im_Jahr=None,Anrede="GemeindeKurz"):
        # zu Testzwecken:
        # im_Jahr = 2004
        if im_Jahr is None:
            im_Jahr = heute.year()
        ab_alter = abs(int(ab_alter))
        # Vorsicht, User...!
        geburtstagsliste = []
        dictarray = self.JahresListe("Geburtstag",nurAktiveGlieder=nur_aktive)
        # webobjekt = gemeindekarteiweb.GemeindeverwaltungWeb(dictarray,"dummyzentrale",self.Spaltennamen)
        # Diese Konstruktion ist zur Sicherheit fr den Fall, da der Anwender das mxDateTime-Modul
        # installiert hat (dann gibt MySQLDb nmlich solche Objekte zurck fr "date"-Felder.
        # Das Webobjekt arbeitet mit einer einigermaen sicheren Parser-Funktion mit regulren
        # Ausdrcken und wandelt alles in das deutsche Format "xx.xx.xxxx" um.
        # dictarray = self.datumUmwandeln(webobjekt.dictarray,kategorie="Geburtstag",sprache="deutsch")
        dictarray = self.datumUmwandeln(dictarray,kategorie="Geburtstag")
        # *** Hier wird die Datumsumwandlung an dieser Stelle vollzogen, weil mit der Ausgabe
        # *** keine weiteren Abfragen der Datenbank verbunden sind.
        # *** Eigentlich nicht ganz konsistent...
        for i in dictarray:
            alter = i["Geburtstag"].alter_geburtstag(im_Jahr)
            if (alter >= ab_alter) or (alter % 10 == 0):
                anrede = ""
                if Anrede_verwenden == "ja":
                    anrede = self.anredeAllgemein(i["Geschlecht"],Anrede)
                ort = i['Wohnort']
                tag,monat = "?","?"
                if alter != "-":
                    # nur, wenn in der Kartei ein Geburtsdatum
                    # eingetragen ist:
                    tag = i['Geburtstag'].day()
                    monat = i['Geburtstag'].monthName()
                text = "%s. %s: %s %s %s, %s, %s Jahre" % (tag,monat,anrede,i['Vorname'],i['Nachname'],ort,alter)
                if nur_aktive == "nein":
                    temptext = ""
                    if i['Status'][:7] != "Kirchen":
                        temptext += "%s," % i['Status']
                    if i['abgegangen'] != "nein":
                        temptext += "abgegangen,"
                    if temptext != "":
                        text += " (%s)" % temptext[:-1]
                        # letztes Komma weg
                geburtstagsliste.append(text)
        return geburtstagsliste

    def JahresListe(self,sortierkategorie,spalten=None,rueckgabe="dictionary",nurAktiveGlieder="ja"):
        where = ""
        if nurAktiveGlieder == "ja":
            where = """where Status like "Kirchen%" and abgegangen like "nein" """
        return  verwaltungmysql.MySQLZugriff.JahresListe(self,sortierkategorie,spalten,rueckgabe,where)

    def sortierteListe(self,sortierkategorie,spaltenliste=None,rueckgabe="dictionary",nurAktiveGlieder="ja"):
        where = ""
        if nurAktiveGlieder == "ja":
            where = """where Status like "Kirchen%" and abgegangen like "nein" """
        return verwaltungmysql.MySQLZugriff.sortierteListe(self,sortierkategorie,spaltenliste,rueckgabe,where)

    def ungeprueftListe(self):
        where = """where geprueft like "nein" """
        return verwaltungmysql.MySQLZugriff.sortierteListe(self,"Nachname",None,"dictionary","""where geprueft like "nein" """)

    def csvDateiImportieren(self,datei="",trenner="\t"):
        """Importiert eine CSV-Datei, wandelt Datumseintrge um, und speichert das Ganze
        in der Gemeindekartei mit Kategorie "geprueft" = "nein" """
        textwerkzeug = textutilities.Textutilities()
        matrix = textwerkzeug.csvdatei_einlesen(datei=datei,trenner=trenner,datumumwandeln="ja",nichtaendern=["Telefon","Fax"])
        if matrix == 0:
            return 0
        # Erste Zeile enthlt Spaltennamen:
        spalten = matrix[0]
        for i in spalten:
            if i not in self.Spaltennamen:
                print """Fehler bei Import: Kategorie "%s" kommt nicht in der Gemeindekartei vor.""" % i
                return 0
        daten = matrix[1:]
        #print spalten
        #print daten
        datendicts = self.alsDictionary(spalten,daten)
        for i in datendicts:
            i["geprueft"] = "nein"
            # zum Testen:
            i["Kirchenbuch"] = "Testglied"
            self.neuerEintrag(i)
            #print i            
        return 1

class GemeindekarteiEvangKath(GemeindekarteiNormal):
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="dummy",tabelle="gemeindekartei"):
        GemeindekarteiNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    def JahresListe(self,sortierkategorie,spalten=None,rueckgabe="dictionary",nurAktiveGlieder="ja"):
        where = ""
        if nurAktiveGlieder == "ja":
            where = """where Status like "Gemeindeglied" and abgegangen like "nein" """
        return  verwaltungmysql.MySQLZugriff.JahresListe(self,sortierkategorie,spalten,rueckgabe,where)

    def sortierteListe(self,sortierkategorie,spaltenliste=None,rueckgabe="dictionary",nurAktiveGlieder="ja"):
        where = ""
        if nurAktiveGlieder == "ja":
            where = """where Status like "Gemeindeglied" and abgegangen like "nein" """
        return verwaltungmysql.MySQLZugriff.sortierteListe(self,sortierkategorie,spaltenliste,rueckgabe,where)

    def geburtstageGemeindebrief(self,ab_alter=65,nur_aktive="ja",Anrede_verwenden="ja",im_Jahr=None,Anrede="Foermlich"):
        return GemeindekarteiNormal.geburtstageGemeindebrief(self,ab_alter,nur_aktive,Anrede_verwenden,im_Jahr,Anrede)

class GemeindekarteiEmkAdressen(GemeindekarteiNormal):
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="dummy",tabelle="gemeindekartei"):
        GemeindekarteiNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",defaultsuche="nein",sortierkategorie="Nachname",abkuerzungen=[],abk_liste=[]):
        # die Defaultsuche mu immer "nein" sein (wegen Status usw.)
        return GemeindekarteiNormal.eintragSuchfunktion(self,suchdict=suchdict,datumumwandeln=datumumwandeln,defaultsuche="nein",sortierkategorie=sortierkategorie,abkuerzungen=abkuerzungen,abk_liste=abk_liste)

    def sortierteListe(self,sortierkategorie="Nachname",spaltenliste=None,rueckgabe="dictionary",nurAktiveGlieder="ja",where=""):
        return verwaltungmysql.MySQLZugriff.sortierteListe(self,sortierkategorie=sortierkategorie,spaltenliste=spaltenliste,rueckgabe=rueckgabe,where=where)

    def alleBezirkeKonferenz(self,konferenz="alle"):
        # Achtung, Test:
        # bei den Datenbanken emkadressen_neu wird alles aus der Ordnungsnummer hergeleitet,
        # die Funktion findet sich deshalb in zuordnungenmysql
        """Es werden nur die Bezirke zurckgegeben, fr die mindestens eine
        Person (Pastor oder Laie) eingetragen ist."""
        sortierwerkzeug = sortieren.Sortieren()
        wherestring = ""
        if konferenz != "alle":
            wherestring = """where Konferenz like "%s" """ % konferenz
        templist1 = self.werteListe(kategorie="Bezirk1",distinct="ja",wherestring=wherestring,leere_entfernen="ja")
        templist2 = self.werteListe(kategorie="Bezirk2",distinct="ja",wherestring=wherestring,leere_entfernen="ja")
        tempdict = {}
        for i in templist1:
            tempdict[i] = ""
        for i in templist2:
            tempdict[i] = ""
        try:
            return sortierwerkzeug.alphabethSort(tempdict.keys())
        except:
            return []

    def eintragPruefen(self,pruefdict,nichtleer=["Nachname","Vorname"]):
        nichtleer = nichtleer
        for i in nichtleer:
            test = pruefdict.get(i,"")
            #print "%s: %s" % (i,test)
            if (not test) or (test=="0000-00-00") or (test=="-"):
                print "Achtung, Feld %s ist leer!" % i

 ##   def abkuerzungenPruefen(self,dict,alleAbkuerzungen=[]):
##        """Prft auf korrekte Anwendung von Abkrzungen, vgl. Abk_Gemeindekartei
##        in Optionen."""
##        dict = dict
##        flag = GemeindekarteiNormal.abkuerzungenPruefen(self,dict=dict,alleAbkuerzungen=alleAbkuerzungen)
##        # Achtung, Test:
##        abkuerzungen = self.optionen.bezirke[1:] # Anfangs-"-" weg
##        alleAbkuerzungen = ["Bezirk"]
##        for kategorie in alleAbkuerzungen:
##            temp = self.Textwerkzeug.abkuerzungenTesten(dict.get(kategorie,"-"),abkuerzungen)
##            if temp["TestText"] != "-" and temp["TestText"] != "":
##                print "Ungltiger Bezirksname verwendet!"
##                print "Falscher Datensatz: %s" % dict
##                flag = 0
##        return flag

    def csvDateiImportieren(self,datei="",trenner="\t"):
        """Importiert eine CSV-Datei, wandelt Datumseintrge um, und speichert das Ganze
        in der Gemeindekartei mit Kategorie "geprueft" = "nein" """
        textwerkzeug = textutilities.Textutilities()
        matrix = textwerkzeug.csvdatei_einlesen(datei=datei,trenner=trenner,datumumwandeln="ja",nichtaendern=["Telefon","Fax","EMail"])
        if matrix == 0:
            return 0
        # Erste Zeile enthlt Spaltennamen:
        spalten = matrix[0]
        for i in spalten:
            if i not in self.Spaltennamen:
                print """Fehler bei Import: Kategorie "%s" kommt nicht in der Gemeindekartei vor.""" % i
                return 0
        daten = matrix[1:]
        datendicts = self.alsDictionary(spalten,daten)
        for i in datendicts:
            i["geprueft"] = "nein"
            # Achtung, hat keine Kategorie "Kirchenbuch"
            self.neuerEintrag(i)
            #print i            
        return 1

    def emkAdressenReportlabPDF(self,datei="test.pdf",format="A4"):
        """Ein Prototyp, hier "hereingeflickt". Geht nicht mit 2.1 wg. Nested Scopes"""
        format = format
        datei = datei
        from reportlab.platypus import SimpleDocTemplate, BaseDocTemplate,PageTemplate,Paragraph,Spacer,Frame,Table,TableStyle,KeepTogether,PageBreak,ActionFlowable,Image,NextPageTemplate
        from reportlab.platypus.doctemplate import IndexingFlowable
        from reportlab.lib.styles import getSampleStyleSheet
        from reportlab.rl_config import defaultPageSize
        from reportlab.lib.pagesizes import A5
        from reportlab.lib.units import inch, cm
        from reportlab.lib import colors

        PAGE_HEIGHT=defaultPageSize[1]
        PAGE_WIDTH = defaultPageSize[0]
        styles = getSampleStyleSheet()
        Story = []

        class adressenDocTemplate(BaseDocTemplate):
           def __init__(self,filename,**kwargs):
              apply(BaseDocTemplate.__init__,(self,filename),kwargs)
              frame1 = Frame(x1=2*cm,y1=1.5*cm,width=6*cm,height=26*cm,id="1")
              frame2 = Frame(x1=8*cm,y1=1.5*cm,width=6*cm,height=26*cm,id="2")
              frame3 = Frame(x1=14*cm,y1=1.5*cm,width=6*cm,height=26*cm,id="3")
              pt1 = PageTemplate(id="MultiColumns",frames=[frame1,frame2,frame3],onPage=self.eachPage)
              frame3 = Frame(x1=2*cm,y1=1.5*cm,width=17*cm,height=26*cm,id="4")
              pt2 = PageTemplate(id="OneColumn",frames=[frame3])
              self.addPageTemplates(pt1)
              self.addPageTemplates(pt2)
              self.style = styles["Normal"]
              self.style_body = styles["BodyText"]
              self.style_h3 = styles["Heading3"]
              #self.allowSplitting = 0
              self.konferenz = ""

           def eachPage(self,canvas,doc):
               if doc.page != 1:
                   canvas.saveState()
                   canvas.setFont("Helvetica", 14)
                   canvas.setFillColor(colors.black)
                   canvas.drawCentredString(10*cm, 28*cm, doc.konferenz)
                   canvas.setFont("Helvetica", 8)
                   num = "Mein kleines EmK-Adressbuch, Seite %d" % doc.page
                   canvas.drawCentredString(10*cm, 1*cm, num)
                   canvas.restoreState()
               else:                   
                   canvas.saveState()
                   canvas.setFont("Helvetica", 42)
                   canvas.setFillColor(colors.black)
                   canvas.drawCentredString(10*cm, 15*cm, "Mein kleines")
                   canvas.drawCentredString(10*cm, 12*cm, "EmK-Adressbuch")
                   canvas.setFont("Times-Italic",20)
                   canvas.drawCentredString(10*cm, 4.5*cm, "frisch gedruckt am %s" % heute.deutschesFormatText())   
                   canvas.drawCentredString(10*cm, 3*cm, "von Erzgebirge Buch & Medien")                   
                   canvas.restoreState()

           def conditionalAdding(self,templist,dict,category):
              check = dict.get(category)      
              if check and check != "-":
                    temptext = "%s: %s" % (category,dict[category])
                    templist.append(Paragraph(temptext,self.style))
              return templist      

           def dictToParagraph(self,dict,ueberschrift="",zusammen="ja",mitName="ja"):
              dict = dict
              templist = []
              if ueberschrift:
                  templist.append(Paragraph("""%s""" % ueberschrift,self.style_h3))
              temptext1 = "<b>%s, %s</b>" % (dict["Nachname"],dict["Vorname"])
              temptext2 = "%s" % dict["Strasse"]
              temptext3 = "%s %s" % (dict["Postleitzahl"],dict["Wohnort"])
              temptext4 = "Tel.: %s" % dict["Telefon"]
              if mitName == "ja":
                  templist.append(Paragraph(temptext1,self.style))
              templist.append(Paragraph(temptext2,self.style))
              templist.append(Paragraph(temptext3,self.style))
              templist.append(Paragraph(temptext4,self.style))
              templist = self.conditionalAdding(templist,dict,"Fax")
              templist = self.conditionalAdding(templist,dict,"EMail")
              s = Spacer(1,0.2*cm)
              #self.allowSplitting = 1
              if zusammen == "ja":
                  return KeepTogether(templist+[s])
              else:
                  return templist
           

        class adressenDocTemplateA5(adressenDocTemplate):
           def __init__(self,filename,**kwargs):
              apply(BaseDocTemplate.__init__,(self,filename),kwargs)
              frame1 = Frame(x1=1.5*cm,y1=1*cm,width=5.5*cm,height=18.5*cm,id="1")
              frame2 = Frame(x1=8.3*cm,y1=1*cm,width=5.5*cm,height=18.5*cm,id="2")
              pt1 = PageTemplate(id="MultiColumns",frames=[frame1,frame2],onPage=self.eachPage,pagesize=A5)
              frame3 = Frame(x1=1.5*cm,y1=1*cm,width=12*cm,height=18.5*cm,id="4")
              pt2 = PageTemplate(id="OneColumn",frames=[frame3],onPage=self.eachPage,pagesize=A5)
              self.addPageTemplates(pt1)
              self.addPageTemplates(pt2)
              self.style = styles["Normal"]
              self.style.fontSize = 8
              self.style.fontName = "Helvetica"
              self.style.leading = 9
              self.style_body = styles["BodyText"]
              self.style_h3 = styles["Heading3"]
              #self.allowSplitting = 0
              self.konferenz = ""

           def eachPage(self,canvas,doc):
               if doc.page != 1:
                   canvas.saveState()
                   canvas.setFont("Helvetica", 12)
                   canvas.setFillColor(colors.black)
                   canvas.drawCentredString(8*cm, 20.1*cm, doc.konferenz)
                   canvas.setFont("Helvetica", 8)
                   num = "EmK-Adressbuch, Seite %d" % doc.page
                   canvas.drawCentredString(8*cm, 1*cm, num)
                   canvas.restoreState()
               else:                   
                   canvas.saveState()
                   canvas.setFont("Helvetica", 32)
                   canvas.setFillColor(colors.black)
                   #canvas.drawCentredString(6.5*cm, 9*cm, "Mein kleines")
                   canvas.drawCentredString(6.5*cm, 7.5*cm, "EmK-Adressbuch")
                   canvas.setFont("Times-Italic",20)
                   #canvas.drawCentredString(8*cm, 4*cm, "frisch gedruckt am %s" % heute.deutschesFormatText())   
                   #canvas.drawCentredString(8*cm, 3*cm, "von Erzgebirge Buch & Medien")                   
                   canvas.restoreState()

        class docKonferenz(ActionFlowable):
           def __init__(self,konferenz):
              self.konferenz = konferenz
              ActionFlowable.__init__(self)

           def apply(self,doc):
              doc.konferenz = self.konferenz  

        STATUS = {"aoM": ("aoM","Ausserordentliches Mitglied"),
                  "Gr": ("Gemref","Gemeindereferent/in"),
                  "GriA": ("GriA","Gemeindereferent/in in Ausbildung"),
                  "GriR": ("GriR","Gemeindereferent/in im Ruhestand"),
                  "Gs": ("Gemeindeschwester","Gemeindeschwester"),
                  "GsiR": ("GsiR","Gemeindeschwester im Ruhestand"),
                  "L": ("Laie","Laie"),
                  "Lp": ("Lp","Laienprediger/in"),
                  "LpD": ("LmD","Laienprediger/in mit Dienstzuweisung"),
                  "MiG": ("MiG","Mitarbeiter/in im Gemeindedienst"),
                  "P": ("Pastor/in","Pastor/in"),
                  "PaP": ("PaP","Pastor/in auf Probe"),
                  "PiR": ("PiR","Pastor/in im Ruhestand"),
                  "PiS": ("PiS","Pastor/in im Sonderdienst"),
                  "PriR": ("PriR","Prediger/in im Ruhestand"),
                  "Pt": ("Pt","Praktikant/in"),
                  "St": ("Studi","Studierende(r)"),
                  "Sup": ("Sup","Superintendent/in"),
                  "W": ("Witwe","Witwe")}

        STATUSLISTE = ["Sup","P","PiS","PiR","aoM","PaP","L","LpD","Lp","St","Pt","Gs","GsiR","Gr","GriA","GriR","MiG","W"]

        KONFERENZLISTE = ["NJK","OJK","SJK"]

        DISTRIKT = {"D": "Dresden",
                    "Z": "Zwickau"}

        KONFERENZ = {"OJK": "Ostdeutsche",
                     "NJK": "Norddeutsche",
                     "SJK": "Sddeutsche"}

        if format == "A5":
            doc = adressenDocTemplateA5(datei)
        elif format == "A4":
            doc = adressenDocTemplate(datei)
        #doc.handle_nextPageTemplate("TwoColumns")
        status = STATUS.keys()    
             
        ######## Hier startet die eigentliche Verarbeitung: ##############     
        Story.append(Image("EmK-Zeichen1.jpg",width=22,height=22,kind="%"))     
        Story.append(PageBreak()) # fr die erste Seite
        liste = KONFERENZLISTE # nur OJK = [1:2]
        from zuordnungenmysql import ZuordnungenNormal
        zuordnung = ZuordnungenNormal(self.Datenbank,self.buchungsjahr)
        doc.konferenz = "%s Jhrliche Konferenz" % KONFERENZ[liste[0]]
        # muss zuerst initialisiert werden
        ersterDurchgang = 1
        for k in liste:
            bezirke = self.alleBezirkeKonferenz(k)
            werke = zuordnung.alleWerkeKonferenz(k)
            Story.append(docKonferenz("%s Jhrliche Konferenz" % KONFERENZ[k]))
            # ein Ereignis wird ausgelst, um die berschrift ber die Seite zu ndern.
            if not ersterDurchgang:
                Story.append(PageBreak())
            ########################
            Story.append(Paragraph("Bezirke",doc.style_h3))
            for b in bezirke:
                alle = self.eintragSuchfunktion({"Konferenz": k, "Bezirk1": b})
                alle += self.eintragSuchfunktion({"Konferenz": k, "Bezirk2": b})
                templist = [Paragraph("<b>%s</b>" % b, doc.style)]
                for a in alle:
                    try:
                        eintrag = "%s, %s (%s)" % (a["Nachname"],a["Vorname"],a["Status"])
                        templist.append(Paragraph(eintrag,doc.style))
                    except:
                        pass # wenn nichts gefunden wurde
                templist.append(Spacer(1,0.2*cm))
                Story.append(KeepTogether(templist))
            ########################    
            for s in STATUSLISTE:
                ueberschrift =  STATUS[s][1]
                liste = self.eintragSuchfunktion({"Konferenz": k, "Status": STATUS[s][0]})
                for eintrag in liste:
                    p = Spacer(1,0.2*cm)
                    try:
                        p = doc.dictToParagraph(eintrag,ueberschrift)
                    except:
                        if ueberschrift:
                            Story.append(Paragraph(ueberschrift,doc.style_h3)) # fr Status ohne Eintrge
                    ueberschrift = "" # wird zurckgesetzt nach dem ersten Durchgang
                    Story.append(p)
            #######################
            Story.append(NextPageTemplate("OneColumn"))
            Story.append(PageBreak())
            Story.append(Paragraph("Werke/Einrichtungen",doc.style_h3))
            for w in werke:
                alle = zuordnung.eintragSuchfunktion({"WerkEinrichtung": w,"Konferenz": k})
                templist = [Paragraph("<b>%s</b>" % w,doc.style)]
                for einzel in alle:
                    aufgabe,name = einzel["Aufgabe"],einzel["Name"]
                    mz_eintrag = None
                    if einzel["MZ"] != "0":
                        mz_eintrag = (self.schluesselSuchen(einzel["MZ"]))[0]
                    aufgabe_eintrag = ""
                    if aufgabe != "-" and aufgabe != "" and aufgabe != "None":
                        aufgabe_eintrag = "%s: " % aufgabe
                    name_eintrag = ""
                    if name != "-":
                        name_eintrag = "%s" % name
                    status_eintrag = ""
                    if mz_eintrag is not None and mz_eintrag and mz_eintrag["Status"] not in ("","-"):
                        try:
                            status_eintrag = "(%s)" % self.abkuerzungBedeutung(mz_eintrag["Status"])
                        except:
                            pass # fr "schlechte" Eintrge
                    eintrag = "%s%s %s" % (aufgabe_eintrag,name_eintrag,status_eintrag)
                    templist.append(Paragraph(eintrag,doc.style))
                    if einzel["AdresseGesondert"] == "ja":
                        try:
                            templist += doc.dictToParagraph(mz_eintrag,zusammen="nein",mitName="nein")
                        except:
                            pass
                templist.append(Spacer(1,0.2*cm))
                Story.append(KeepTogether(templist))
            Story.append(NextPageTemplate("MultiColumns"))             
            ersterDurchgang = 0
        doc.build(Story)
        f = open(datei,"rb")
        string = f.read()
        f.close()
        return string

class GemeindekarteiEmkAdressen_Neu(GemeindekarteiEmkAdressen):
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="dummy",tabelle="gemeindekartei"):
        GemeindekarteiNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    def tabelleExportierenCSV(self,user,verzeichnis,trenner="\t",sortierkategorie=primaerkartei,schluesselliste=None,mitUmwandlung="nein"):
        return GemeindekarteiNormal.tabelleExportierenCSV(self,user=user,verzeichnis=verzeichnis,trenner=trenner,sortierkategorie=sortierkategorie,schluesselliste=schluesselliste,mitUmwandlung="nein")

    def schluesselListeSuchen(self,schluesselliste,sortierkategorie="Name",zusatzbedingung="",rueckgabe="dictionary",primaerschluessel=primaerkartei):
        return GemeindekarteiNormal.schluesselListeSuchen(self,schluesselliste=schluesselliste,sortierkategorie="Name",zusatzbedingung=zusatzbedingung,rueckgabe=rueckgabe,primaerschluessel=primaerschluessel)

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",defaultsuche="nein",sortierkategorie="Name",abkuerzungen=[],abk_liste=[]):
        # die Defaultsuche mu immer "nein" sein (wegen Status usw.)
        return GemeindekarteiEmkAdressen.eintragSuchfunktion(self,suchdict=suchdict,datumumwandeln=datumumwandeln,defaultsuche="nein",sortierkategorie=sortierkategorie,abkuerzungen=abkuerzungen,abk_liste=abk_liste)

    def sortierteListe(self,sortierkategorie="Name",spaltenliste=None,rueckgabe="dictionary",where="",nurAktiveGlieder="ja"):
        temp = sortierkategorie
        return GemeindekarteiEmkAdressen.sortierteListe(self,sortierkategorie="Name",spaltenliste=spaltenliste,rueckgabe=rueckgabe,where=where,nurAktiveGlieder=nurAktiveGlieder)

    def eintragPruefen(self,pruefdict,nichtleer=["Name","Vorname"]):
        return GemeindekarteiEmkAdressen.eintragPruefen(self,pruefdict=pruefdict,nichtleer=nichtleer)

    def emailListeSuchen(self,schluesselliste,sortierkategorie=None,alsDictarray="ja"):
        # sucht aus einer MZ-Liste alle Eintrge mit bzw. ohne gltige E-Mail-Adresse.
        tempdictarray_email = self.schluesselListeSuchen(schluesselliste=schluesselliste,sortierkategorie="Name",zusatzbedingung="""and (Mail like "%@%" or PrivatMail like "%@%") """)
        tempdictarray_email = self.Textwerkzeug.privatStattDienstlichDictarray(tempdictarray_email)
        tempdictarray_noemail = self.schluesselListeSuchen(schluesselliste=schluesselliste,sortierkategorie="Name",zusatzbedingung="""and Mail not like "%@%" and PrivatMail not like "%@%" """)
        if alsDictarray == "nein":
            return self.Sortierwerkzeug.listeAusDictarray(tempdictarray_email,"Mail"), self.Sortierwerkzeug.listeAusDictarray(tempdictarray_noemail,"Mail")
        else:
            return tempdictarray_email,tempdictarray_noemail

    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel="",protokoll="ja",tabu=tabuschluessel,altdict=None):
        nichtaendern = ['ID','IntBenutzerID','IntBenutzerPWD','DatumErstellt','DatumZuletztGeaendert','Herkunft','Frei1','ABMFachNr','Frei2','PersNr','Frei3','Frei4']
        tabu = tabu + nichtaendern
        return GemeindekarteiNormal.eintragAendern(self,aenderungsdict=aenderungsdict,primaerschluessel=primaerschluessel,schluessel=schluessel,protokoll=protokoll,tabu=tabu,altdict=altdict)

    def eintragAendernProtokoll(self,altdict,aenderungsdict,schluessel):
        datensatz = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: nderung eines Datensatzes\nDatensatz: %s, %s (MZ=%s)\n\nNeue Daten:\n" % (Benutzername,datensatz["Name"],datensatz["Vorname"],datensatz["MZ"])
        for i in aenderungsdict.keys():
            text += "%s: %s => %s\n" % (i,altdict[i],aenderungsdict[i])
        return text

    def neuerEintragProtokoll(self,schluessel,dict):
        #datensatz = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: Anlegen eines neuen Datensatzes\nDatensatz: %s, %s (MZ=%s)\n\nNeue Daten:\n" % (Benutzername,dict["Name"],dict["Vorname"],schluessel)
        for i in dict.keys():
            text += "%s: %s\n" % (i,dict[i])
        return text

    def eintragLoeschenProtokoll(self,schluessel):
        dict = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: Lschen eines Datensatzes\nDatensatz: %s, %s (MZ=%s)\n\nNeue Daten:\n" % (Benutzername,dict["Name"],dict["Vorname"],schluessel)
        for i in dict.keys():
            text += "%s: %s\n" % (i,dict[i])
        return text

    def statusBezeichnung(self,dict,status):
        temp = self.optionen.status.get(dict[status],"-")
        try:
            return "%s" % temp.get(dict["Geschlecht"],"-")
        except:
            return "-"   

    def statusZusammenfassung(self,dict):
        text = ""
        for status in ("Status1","Status2","Status3","Status4","Status5"):
            s = self.statusBezeichnung(dict,status)
            if s != "-":
                text += "%s, "% s
        try:
            return text[:-2]
        except:
            return text

    def statusZusammenfassungKurz(self,dict):
        text = ""
        for status in ("Status1","Status2","Status3","Status4","Status5"):
            s = dict[status]
            if s and s != "-":
                text += "%s,"% s
        try:
            return text[:-1]
        except:
            return text

    def allesExportieren(self):
        tabellen = {"tblAufbau": "tblAufbau.txt",
                    "tblBezEinrichtungPerson": "tblBezEinrichtungPerson.txt",
                    "gemeindekartei": "tblPersonen.txt",
                    "tblBezEinrichtungAdresse": "tblBezEinrichtungAdresse.txt",
                    "tblEinrichtungen": "tblEinrichtungen.txt",
                    "tblEinrichtungBank": "tblEinrichtungBank.txt",
                    "tblPersonBank": "tblPersonBank.txt"}
        liste = tabellen.keys()
        listen_text = ""
        for i in liste:
            befehl = """mysql --user=%s --password=%s --execute="select * from %s" %s > %s""" % (verwaltungMainServer.datenbank_user,verwaltungMainServer.datenbank_passwort,i,self.Datenbankname,verwaltungMainServer.CGI+tabellen[i])
            listen_text += "%s " % tabellen[i]
            os.system(befehl)
        time.sleep(1)        
        befehl = """zip -b %s AlleTabellen %s""" % (verwaltungMainServer.CGI,listen_text)
        # setzt das UNIX-Tool "zip" voraus.
        os.system(befehl)
        for i in liste:
            os.remove(verwaltungMainServer.CGI+tabellen[i])
        datei = open(verwaltungMainServer.CGI+"AlleTabellen.zip","rb")
        inhalt = datei.read()
        datei.close()
        os.remove(verwaltungMainServer.CGI+"AlleTabellen.zip")
        return inhalt
               


        


        

def Gemeindekartei(MysqlDatenbank, buchungsjahr,datenbank="dummy",tabelle="gemeindekartei"):
    """Factory-Funktion fr die Geschmacksrichtungen."""
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)
    if kirche == "metho":
        return GemeindekarteiNormal(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    if kirche in ("evang","kath"):
        return GemeindekarteiEvangKath(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    if kirche == "emkadressen":
        return GemeindekarteiEmkAdressen(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    if kirche == "emkadressen_neu":
        return GemeindekarteiEmkAdressen_Neu(MysqlDatenbank,buchungsjahr,datenbank,tabelle)






        
        


   
