#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import verwaltungmysql
import sortieren
import kontenplan
import types
import htmlutilities
import gemeindekarteimysql
import os
import update
import MySQLdb
import verschiedeneUtilities
import verwaltungMainServer
import cPickle
import md5


primaerkartei = 'Buchungsjahr'
tabuschluessel = [primaerkartei]


class OptionenNormal(verwaltungmysql.MySQLZugriff):
    """Ein solches Objekt verwaltet standardmig immer genau ein Buchungsjahr. Dieses ist in der Datenbank
    auch der Primrschlssel der entsprechenden Zeile.
    Diese Grundklasse ist gleichzeitig speziell fr die Evang.-meth. Kirche."""

    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="optionen"):
        self.buchungsjahr = buchungsjahr
        self.tabelle = "%s%s" % (tabelle,self.buchungsjahr)
        self.emk_adressen_flag = 0
        verwaltungmysql.MySQLZugriff.__init__(self,MysqlDatenbank,datenbank,self.tabelle)
        try:
            self.optionen = self.schluesselSuchen(buchungsjahr)[0]
            # self.buchungsjahr = self.jetztHolen() # damit hat sich die bergabe von "Buchungsjahr" erbrigt...
            self.alleGemeinden = self.alleGemeinden()
            self.alleGrundstuecke = self.alleGrundstuecke()
        except:
            # die Subklasse DummyOptionen soll sich auch initialisieren lassen. Das Design ist nicht optimal...
            pass

    def spaltennamen_gemeindekartei(self):
        """Gibt die Spaltennamen der zugehrigen Gemeindekartei aus."""
        return self.holeSpaltennamen(tabellenname="gemeindekartei")

    def geschmacksrichtung_bestimmen(self):
        """Gibt die "Geschmacksrichtung" der gewhlten Datenbank an, z.B. "metho","evang","kath"...
        Wird beim Login aufgerufen zur Analyse und dem Eintrag in verwaltungMainServer.GeschmacksDict."""
        global EMK_ADRESSEN
        EMK_ADRESSEN = 0
        liste = self.spaltennamen_gemeindekartei()        
        if "eingesegnet" in liste:
            return "metho"
        elif "konfirmiert" in liste:
            return "evang"
        elif "Erstkommunion" in liste:
            return "kath"
        elif "Konferenz" in liste:
            if "ID" in liste:
                return "emkadressen_neu"
            else:
                return "emkadressen"

    def gemeindekartei_optionsfelder(self):
        temp =  {'abgegangen': ('nein','ja'),
                 'Abgangsgrund' : ('-','verstorben','Gliederaufnahme(KA)','Einsegnung(Kind)','berweisung','bertritt in andere Kirche','Austritt','Streichung','Ausschluss'),
                 'Zugangsgrund': ('-','Gliederaufnahme(KG)','auf Antrag(KA)','Einsegnung(KA)','Taufe/Antrag(Kind)','berweisung','bertritt'),
                 'Geschlecht': ('wl','ml'),
                 'Familienstand': ('-','led.','verh.','verw.','gesch.'),
                 'Status': ('-','Kirchenglied','Kirchenangehriger','Kind','Freund','Spender(extern)','Mitarbeiter(extern)','Sonstige'),
                 'geprueft': ('ja','nein'),
                 'Gemeinde': self.alleGemeinden
                 }
        # ist durch die EmK-Statistik-Formulare vorgegeben
        return temp

    def baukonto_optionsfelder(self):
        kontenplanwerkzeug = kontenplan.BaukontoKontenplan(self.Datenbank,self.buchungsjahr)
        habenkonten =  kontenplanwerkzeug.habenkontenListeWeb()
        sollkonten = kontenplanwerkzeug.sollkontenListeWeb()
        # Die Optionsfelder werden z.T. aus der Datenbank (kontenplan) geholt.
        temp = {"Habenkonto_1": habenkonten,
                "Habenkonto_2": habenkonten,
                "Habenkonto_3": habenkonten,
                "Sollkonto_1": sollkonten,
                "Sollkonto_2": sollkonten,
                "Sollkonto_3": sollkonten,
                "Squittung_noetig": ["nein","kirchlich","mildttig"],
                "Grundstueck": self.alleGrundstuecke,
                "Gemeinde": self.alleGemeinden
                }
        return temp

    def kontenplan_optionsfelder(self):
        temp = {"Direktbuchung": ["nein","ja"],
                "GemeindeNoetig": ["nein","ja"],
                "MZNoetig": ["nein","ja"],
                "GrundstueckNoetig": ["nein","ja"],
                "SollMoeglich": ["nein","ja"],
                "HabenMoeglich": ["nein","ja"]
                }
        return temp
        
        
    def primaerschluessel(self):
        return primaerkartei

    def druckAnzahl(self):
        return int(self.optionen["DruckAnzahl"])

    def alleSpendenkonten(self):
        return self.optionen["SQuittung_Konten"].split()

    def alleAbkuerzungenGemeindekartei(self):
        return self.optionen["Abk_Gemeindekartei"].split()

    def alleAbkuerzungenGesangbuch(self):
        return self.optionen["Abk_Gesangbuch"].split()

    def alleSpendenkontenSQL(self):
        return self.listeAlsSQL(self.alleSpendenkonten())

    def alleBuchungsjahre(self,datenbank=None):
        if datenbank is None:
            datenbank = self.Datenbankname
        buchungsjahre = []
        for i in self.alleTabellen(datenbank):
            try:                
                if i[:8] == "optionen":
                    buchungsjahre.append(i[8:])
            except:
                # falls die Slicing-Operationen fehlschlagen...
                pass
        return buchungsjahre

    def gueltigeLogins(self):
        """Gibt alle gueltigen Datenbank/Buchungsjahr-Kombinationen, Mysql-Rechte werden bercksichtigt."""
        liste = []
        for datenbank in self.eigeneDatenbanken():
            try:
                for buchungsjahr in self.alleBuchungsjahre(datenbank):
                    liste.append([datenbank,buchungsjahr])
            except:
                # Wenn keine Buchungsjahre vorhanden oder keine Rechte fr die Datenbank.
                pass
        liste.sort()
        return liste

    def alleVorlagen(self,spenden="nein"):
        dir = self.optionen["Serienbriefverzeichnis"]
        alle = os.listdir(dir)
        allevorlagen = []
        for file in alle:
            if os.path.isfile(os.path.join(dir,file)) and ((file.lower()[-3:] == "rtf") or (file.lower()[-3:] == "sxw")):
                if spenden == "ja" and file.lower()[:7] == "spenden":
                    allevorlagen.append(file)
                    # nur die Spendenvorlagen
                if spenden == "nein" and file.lower()[:7] != "spenden":
                    allevorlagen.append(file)
                    # alle, auer den Spendenvorlagen
        allevorlagen.sort()
        return allevorlagen

    def alleSicherungen(self):
        dir = self.optionen["Sicherungsverzeichnis"]
        re_sicherung = re.compile(r"(%sbackup|update).*sql" % self.Datenbankname)
        # so knnen sowohl Backup- als auch Update-SQL's eingelesen werden.
        alle = os.listdir(dir)
        allesicherungen = []
        for file in alle:
            test = re_sicherung.search(file)
            if os.path.isfile(os.path.join(dir,file)) and test:
                allesicherungen.append(file)
        allesicherungen.sort()
        return allesicherungen 

    def alleGemeinden(self):
        # zum Buchen brauchen wir nicht fr alle Konten eine Gemeinde, deshalb das "-"
        return ["-"] + self.optionen["Gemeinden"].split()

    def alleGrundstuecke(self):
        return ["-"] + self.optionen["Grundstuecke"].split()

    def tabuschluesselEntfernen(self,dict):
        return verwaltungmysql.MySQLZugriff.tabuschluesselEntfernen(self,dict,tabuschluessel)

##    def jetztHolen(self):
##        """Ein Trick, um eine weitere Tabelle zu vermeiden: im Buchungsjahr "jetzt"
##        wird unter "Gemeinde_1" das aktuelle Buchungsjahr gespeichert, mit dem in der
##        Bezirksreiter-Sitzung gerade gearbeitet wird."""
##        return self.schluesselSuchen("jetzt")[0]["Gemeinde_1"]

##    def jetztSetzen(self,jetztwert):
##        dict = {"Gemeinde_1": jetztwert}
##        return self.eintragAendern(dict,"jetzt")        
        

    def neuerEintrag(self,neudict,primaerdummy=primaerkartei,schluesselwert=None,tabelle=None):
        """berschreibt die Funktion in der bergeordneten Klasse MySQLZugriff.
        Beachte wieder oben die Dummy-Werte."""
        if schluesselwert is None:
            schluesselwert = self.buchungsjahr
        if tabelle is None:
            tabelle = self.Tabellenname
        primaerdummy = primaerkartei
        uebergabedict = self.holeLeerenEintrag()
        uebergabedict.update(neudict)
        uebergabedict.update({primaerkartei: schluessel})        
        return self.neuerEintragDirekt(uebergabedict)
    
    def eintragVergleichen(self,schluessel=None,vergleichdict={}):
        if schluessel is None:
            schluessel = self.buchungsjahr
        urdict = self.schluesselSuchen(schluessel)
        vergleichdictvollstaendig = self.leererEintrag
        vergleichdictvollstaendig.update(vergleichdict)
        # wichtig, wenn in vergleichdict bestimmte Eintrge fehlen,
        # die z.B. in einem Eingabeformular von "Name" auf "" gesetzt wurden.
        # Sie wrden sonst nicht verglichen (vgl. die Superklasse).
        return verwaltungmysql.MySQLZugriff.eintragVergleichen(self,{primaerkartei: schluessel},vergleichdictvollstaendig)

    def schluesselSuchen(self,schluessel=""):
        if schluessel == "":
            schluessel = self.buchungsjahr
        return self.eintragSuchfunktion({primaerkartei: schluessel})

    def eintragAendern(self,aenderungsdict,Buchungsjahr=None):
        if Buchungsjahr is None:
            Buchungsjahr = self.buchungsjahr
        if aenderungsdict.has_key(primaerkartei):
            # kein ndern des Primrschlssels!
            del aenderungsdict[primaerkartei]
        ##for value in aenderungsdict.values():
##            backslash = "\\"
##            value = value.replace(backslash,backslash*4)
##            print value
        return verwaltungmysql.MySQLZugriff.eintragAendern(self,aenderungsdict,primaerkartei,Buchungsjahr)

    def mysqlRootCursor(self,mysql_passwort="",user="root"):
        try:
            if self.win:
                return MySQLdb.connect(db="test",host="localhost",user="ODBC").cursor()
            else:
                return MySQLdb.connect(db="test",host="localhost",user=user,passwd=mysql_passwort).cursor()
        except:
            print "Fehler beim Verbinden zur MySQL-Datenbank. Fehlende Datenbankrechte?"
            return 0        

    def neueDatenbankRechte(self,neueDatenbank,admin_passwort,mysql_passwort="",user="root"):
        # Erzeugen der Datenbank-Rechte fr den Bezirksreiter-User "einzelplatz"
        root_cursor = self.mysqlRootCursor(mysql_passwort=mysql_passwort,user=user)
        if not root_cursor:
            return 0
        root_cursor.execute("""grant all on %s.* to %s@localhost identified by "%s" """ % (neueDatenbank,verwaltungMainServer.datenbank_user,verwaltungMainServer.datenbank_passwort))
        root_cursor.execute("""flush privileges""")
        # Erzeugung des neue Codes fr Admin-Zugang
        datei = open(verwaltungMainServer.CGI+"checkin","rb")
        dict = cPickle.load(datei)
        datei.close()
        temp = verwaltungMainServer.NAME_ADMIN+admin_passwort+verwaltungMainServer.CHECKIN_ADD+"%s" % neueDatenbank
        code = md5.new(temp).hexdigest()
        dict[neueDatenbank] = {verwaltungMainServer.NAME_ADMIN: (code,verwaltungMainServer.EMAIL_ADMIN,"a","mail")}
        datei = open(verwaltungMainServer.CGI+"checkin","wb")
        cPickle.dump(dict,datei)
        datei.close()
        verwaltungMainServer.CHECKIN = dict # Neuzuweisung - sonst bleiben die alten Werte im Speicher
        return 1

    def neueDatenbank(self,neueDatenbank,kopieren="nein"):
        """Erzeugt aus der aktuellen Datenbank (nur aktuelles Buchungsjahr) eine neue, leere Datenbank.
        Beibehalten von den Daten wird nur der Kontenplan und die Einstellungen unter "Optionen".
        Mit kopieren="ja" kann die gesamte Datenbank mit allen Buchungsjahren usw. kopiert werden.
        """
        tabellenNeu = []
        if neueDatenbank in self.alleDatenbanken():
            print "Datenbank %s schon vorhanden." % neueDatenbank
            return 0
        for i in neueDatenbank:
            if i not in string.letters:
                print "Der Datenbankname darf keine Umlaute oder Sonderzeichen enthalten."
                return 0
        if len(neueDatenbank) < 4:
            print "Der Datenbankname mu mindestens aus drei Zeichen bestehen."
            return 0
        else:
            try:
                self.Cursor.execute("""create database %s""" % neueDatenbank)
            except:
                print "Die Datenbank %s konnte nicht erzeugt werden. Fehlende Datenbank-Rechte?" % neueDatenbank
                return 0
        if kopieren != "ja":
            tabellen = (("baukontoneu","nein"), ("baukontoneu_kontenplan","ja"), ("baukontoneu_vorlagen","nein"), ("optionen","ja"))        
            tabellenNeu = [("%s%s" % (i[0],self.buchungsjahr),i[1]) for i in tabellen]
            tabellenNeu.append(("abkuerzungen","ja"))
            tabellenNeu.append(("gemeindekartei","nein"))
        elif kopieren == "ja":
            for i in self.alleTabellen():
                tabellenNeu.append((i,"ja"))                
        for i in range(len(tabellenNeu)):
            test = self.tabelleKopieren(alteTabelle=tabellenNeu[i][0],neueTabelle=tabellenNeu[i][0],Mysqlverzeichnis=self.optionen["Datenbankverzeichnis"],mitDaten=tabellenNeu[i][1],erzwingen="ja",neueDatenbank=neueDatenbank)
            # Option erzwingen="ja" ist ntig, sonst werden stndig die bereits erstellten Tabellen gefunden und das Kopieren abgebrochen.
        return 1

    def neuesBuchungsjahr(self):
        """Erzeugt ein neues Buchungsjahr aus einer Vorlage."""
        # Achtung: dabei mu bei "optionen" im neuen Jahr der Primrschlssel auf das neue Jahr
        # gesetzt werden. Das geht nicht mit "eintragAendern" (s.o.)
        tabellen = (("baukontoneu","nein"), ("baukontoneu_kontenplan","ja"), ("baukontoneu_vorlagen","ja"), ("optionen","ja"))
        # in den Tupeln ist angegeben, ob mit oder ohne vorhandene Daten kopiert werden soll.
        tabellenAlt = [("%s%s" % (i[0],self.buchungsjahr),i[1]) for i in tabellen]
        neuesBuchungsjahr = "%s" % (int(self.buchungsjahr) + 1)
        tabellenNeu = [("%s%s" % (i[0],neuesBuchungsjahr),i[1]) for i in tabellen]
        for i in tabellenNeu:
            if i[0] in self.alleTabellen():
                print "Neues Buchungsjahr %s schon in Datenbank %s vorhanden!" % (neuesBuchungsjahr,self.Datenbankname)
                return 0
        for i in range(len(tabellenNeu)):
            # print tabellenAlt[i],tabellenNeu[i]
            test = self.tabelleKopieren(alteTabelle=tabellenAlt[i][0],neueTabelle=tabellenNeu[i][0],Mysqlverzeichnis=self.optionen["Datenbankverzeichnis"],mitDaten=tabellenNeu[i][1],erzwingen="ja")
            # zu erzwingen="ja" s.o. neueDatenbank
            if not test:
                for i in tabellenNeu:
                    befehl = """drop table if exists %s""" % i[0]
                    self.Cursor.execute(befehl)
                    # Aufrumen, falls aus dem milungenen Versuch schon einzelne neue Tabellen entstanden sind.
                return 0
        befehl = """update %s%s set Buchungsjahr="%s" where Buchungsjahr like "%s" """ % ("optionen",neuesBuchungsjahr,neuesBuchungsjahr,self.buchungsjahr)
        self.Cursor.execute(befehl)
        # Eintrag des neuen Buchungsjahrs in der neuen optionen-Tabelle s.o.
        befehl = """update %s%s set abgeschlossen="nein" where abgeschlossen like "ja" """ % ("optionen",neuesBuchungsjahr)
        # Das neue Buchungsjahr ist natrlich noch nicht abgeschlossen.
        self.Cursor.execute(befehl)
        befehl = """update %s%s set abgeschlossen="ja" where abgeschlossen like "nein" """ % ("optionen",self.buchungsjahr)
        # Das alte Buchungsjahr wird abgeschlossen.
        self.Cursor.execute(befehl)
        return 1

    def updateInfo(self):
        updatewerkzeug = update.UniversalUpdate()
        versionsdict = updatewerkzeug.versionsinfoHolen()
        if versionsdict == 0:
            return 0
        empfehlungen = {}
        if versionsdict["update"]["versionsnummer"] > versionsdict["alt"]["versionsnummer"]:
            empfehlungen["update_noetig"] = "Sie haben eine alte Bezirksreiter-Version. Ein Update wird dringend empfohlen!"
            if versionsdict["update"]["sql_einlesen"] >= versionsdict["alt"]["versionsnummer"]:
                empfehlungen["update_noetig"] += " Der Aufbau der Datenbanken sollte veraendert/ergaenzt werden. Erstellen sie vorher Sicherungen! Achtung: Das Neueinlesen der Datenbanken ist noch nicht automatisch gelst. Bitte E-Mail an me.simon@t-online.de!"
            else:
                empfehlungen["update_noetig"] += " Die Datenbanken muessen dabei nicht veraendert/ergaenzt werden."
        elif versionsdict["update"]["letztesUpdate"] > versionsdict["alt"]["letztesUpdate"]:
            empfehlungen["update_noetig"] = "Sie haben eine aktuelle Bezirksreiter-Versionsnummer, aber eine ltere Installation als diejenige auf der Bezirksreiter-Homepage. Bitte beachten Sie ggf. die besonderen Hinweise."
        else:
            empfehlungen["update_noetig"] = "Sie haben eine aktuelle Bezirksreiter-Version. Ein Update ist nicht ntig."
        empfehlungen["hinweise"] = versionsdict["update"]["hinweise"]
        versionsdict["empfehlungen"] = empfehlungen
        return versionsdict

class OptionenEvangKath(OptionenNormal):
    """Die Version fr die evangelische Landeskirche und kath. Kirche (mu noch angepat werden."""
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="optionen"):
        OptionenNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    def alleGrundstuecke(self):
        return ["-"] # in den Light-Datenbanken werden keine Grundstcke gespeichert.

    def gemeindekartei_optionsfelder(self):
        temp =  {'abgegangen': ('nein','ja'),
                 'Abgangsgrund' : ('-','verstorben','Wegzug','bertritt in andere Kirche','Austritt','Ausschluss'),
                 'Zugangsgrund': ('-','Taufe','Getaufte(r) auf Antrag','Zuzug','bertritt aus anderer Kirche'),
                 'Geschlecht': ('wl','ml'),
                 'Familienstand': ('-','led.','verh.','verw.','gesch.'),
                 'Status': ('-','Gemeindeglied','Spender(extern)','Mitarbeiter(extern)','Sonstige'),
                 'geprueft': ('ja','nein'),
                 'Gemeinde': self.alleGemeinden
                 }
        # ist durch die EmK-Statistik-Formulare vorgegeben
        return temp

    def baukonto_optionsfelder(self):
        kontenplanwerkzeug = kontenplan.BaukontoKontenplan(self.Datenbank,self.buchungsjahr)
        einnahmekonten =  kontenplanwerkzeug.kontenListeWeb("Einnahmen")
        ausgabekonten = kontenplanwerkzeug.kontenListeWeb("Ausgaben")
        # Die Optionsfelder werden z.T. aus der Datenbank (kontenplan) geholt.
        temp = {"Einnahmen": einnahmekonten,
                "Ausgaben": ausgabekonten,
                "Squittung_noetig": ["nein","kirchlich","mildttig"],
                "Gemeinde": self.alleGemeinden
                }
        return temp

    def kontenplan_optionsfelder(self):
        temp = {"Direktbuchung": ["nein","ja"],
                "GemeindeNoetig": ["nein","ja"],
                "MZNoetig": ["nein","ja"],
                "EinnahmenAusgaben": ["Einnahmen","Ausgaben"]
                }
        return temp

class OptionenEmkAdressen(OptionenEvangKath):
    """Die Version fr die Emk-Adressdatei. Nur wenig modifiziert."""    
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="optionen"):
        OptionenEvangKath.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)
        self.bezirke = ("-","Aalen","Abstatt-Happenbach","Albstadt-Ebingen","Albstadt-Tailfingen","Altenburg","Altenpflegeheim Freudenquell","Altensteig","Ammerbuch-Entringen","Annaberg-Buchholz","Ansbach","Asperg","Aue","Auerbach","Augsburg","Backnang","Bad Kreuznach","Bad Kreuznach / Mandel","Baden-Baden / Loffenau","Baden-Baden/Loffenau","Baiersbronn","Balingen","Bayreuth","Bebra/Eisenach","Beilstein","Berlin","Berlin-Buch / Zepernick","Berlin-Charlottenburg","Berlin-Charlottenburg (englischsprachig)","Berlin-Friedenau/Schneberg","Berlin-Friedrichshain","Berlin-Kreuzberg","Berlin-Lankwitz","Berlin-Marzahn","Berlin-Mitte","Berlin-Neuklln","Berlin-Oberschneweide","Berlin-Reinickendorf","Berlin-Spandau","Berlin-Tegel","Berlin-Wittenau","Besigheim","Besigheim-Ottmarsheim","Bielefeld","Bietigheim","Bildungswerk","Birkenfeld","Bochum","Bockau / Albernau","Bookholzberg","Brand-Erbisdorf","Braunfels","Braunschweig/Clausthal","Breitenbrunn","Bremen","Bremen-Nord","Bremerhaven","Bretten / Krnbach","Bretten/Krnbach","Brombach","Bruchsal / Kraichtal","Bruchsal/Kraichtal","Burkhardtsdorf","Bblingen","Calw","Chemnitz-Erlserkirche / Flha","Chemnitz-Friedenskirche","Cottbus","Crailsheim","Crossen","Crottendorf","Darmstadt","Delmenhorst","Dessau","Detmold","Diakoniewerk Bethanien","Diakoniewerk Bethanien Heidelberg","Diakoniewerk Bethanien-Hamburg","Diakoniewerk Bethesda","Diakoniewerk Bethesda Wuppertal","Diakoniewerk Bethesda e.V.","Diakoniewerk Chemnitz","Diakoniewerk Martha-Maria","Diakoniewerk Martha-Maria Halle","Diakoniewerk Martha-Maria Nrnberg","Dillenburg","Dittersdorf","Dornhan","Dortmund","Dreieich-Sprendlingen","Dresden","Dresden-Emmaus","Dresden-Emmauskirche","Dresden-Friedenskirche","Dresden-Immanuelkirche","Dresden-Zionskirche","Dresden-lmmanuelkirche","Duisburg","Dsseldorf","Eberswalde","Edewecht","Ehrenfriedersdorf","Eibenstock","Eichwalde","Ellefeld","Ellerbek","Eppingen / Sinsheim","Eppingen/Sinsheim","Erfurt","Essen","Esslingen","Eutingen","Evangelisationswerk","Fachklinik Klosterwald","Falkenstein","Fellbach","Flensburg","Frankfurt","Frankfurt-Innenstadt","Frankfurt-Rufer","Frankfurt-Ruferkirche","Frauenwerk","Freiburg","Freudenstadt","Friedrichsdorf","Frth / Erlangen","Frth/Erlangen","Geislingen / Steige","Geislingen/Steige","Gelenau","Gelsenkirchen/Wanne-Eickel","Genthin","Gera","Ghanaische Gemeinden Rhein/Ruhr","Ghanaischer Bezirk Hamburg","Greiz","Groalmerode","Groenhain","Grtzingen","Grnhain","Gppingen","Grlitz","Gglingen","Halle","Hamburg","Hamburg-Eimsbttel","Hamburg-Eppendorf","Hamburg-Fuhlsbttel","Hamburg-Fuhlsbttel (international)","Hamburg-Hamm","Hamburg-Harburg","Hamburg-Wilhelmsburg","Hamm","Hannover (Immanuelkirche)/Hildesheim","Hannover-Johanneskirche","Heidelberg","Heidenheim","Heilbronn-Bckingen","Heilbronn-Friedenskirche","Heilbronn-Paulus","Heilbronn-Pauluskirche","Herges-Hallenberg","Herold","Herrenberg","Hockenheim","Hof","Hof - Stammbach","Hof/Saale","Jena / Weimar","Kaiserslautern","Karlsruhe","Karlsruhe-Durlach","Kassel","Kiel","Kinder- und Jugendwerk","Kinder-u. Jugendwerk","Kinderwerk","Kirchberg","Kirchenkanzlei","Kirchhain","Kirchheim / Teck","Kirchheim/Teck","Knittlingen / Bauschlott","Konstanz","Kln / Bonn","Kln/Bonn","Knigswalde","Lage","Lahr","Laichingen","Lauter","Lebenszentrum Ebhausen","Leer","Leinfelden-Echterdingen","Leipzig-Bethesdakirche","Leipzig-Kreuzkirche","Leutenberg / Schwarzenshof","Lobenstein / Remptendorf","Lohra","Ludwigsburg","Ludwigshafen / Neustadt","Lnderjugendwerk Berlin-Brandenburg","Lbeck","Magdeburg","Mainz","Mandel","Mannheim","Marbach","Marbach / Neckar","Marbach am Neckar","Marienberg/Olbernhau","Medienwerk","Metzingen","Minden","Moskau","Murrhardt","Mssingen","Mhlacker","Mhlheim","Mhlheim am Main","Mlheim an der Ruhr","Mnchen-Enhuberstrae","Mnchen-Friedenskirche","Mnchen-Peace Church","Mnsingen","Nagold","Naila","Nellingen","Netzschkau","Neubrandenburg","Neudorf","Neuenbrg","Neuenhain","Neuruppin","Neuschoo/Aurich","Niederdorf / Lnitz","Nrnberg-Martha Maria","Nrnberg-Paulus","Nrnberg-Pauluskirche","Nrnberg-Zion","Nrnberg-Zionskirche","Nrtingen","hringen","Oelsnitz","Oldenburg","Osnabrck","Ottmarsheim","Pegnitz","Pflegeheim Meerholz","Pforzheim","Pfullingen","Pirmasens","Plauen","Pliezhausen","Plochingen","Potsdam","Raschau","Recklinghausen / Marl","Regensburg","Reichenbach","Reinsdorf / Mlsen","Remscheid","Reutlingen","Reutlingen-Betzingen","Reutlingen-Erlserkirche","Rodewisch","Rostock","Rothenbergen","Rudersberg","Rundfunkmission","Rutesheim","Saar","Schleiz","Schneeberg","Schorndorf","Schwabach/Weienburg","Schwarzenberg","Schweinfurt / Wrzburg","Schwenningen-Friedenskirche","Schwbisch Hall","Schnaich","Schneck-Markneukirchen","Schnheide","Seewald-Besenfeld","Siegen","Simmern","Simmern / Hunsrck","Sindelfingen","Solingen","Speyer / Kandel","Split","St. Georgen","Stiftung Sozialwerk Sd","Stuttgart","Stuttgart-Auferstehungskirche","Stuttgart-Bad Cannstatt","Stuttgart-Feuerbach","Stuttgart-Vaihingen","Stuttgart-Wangen","Stuttgart-Weilimdorf","Stuttgart-Zionskirche","Stuttgart-Zuffenhausen","Sttzengrn","Theologisches Seminar","Thringer Wald","Treuen","Triebes","Tuttlingen","Tbingen","berlingen","berlingen / Friedrichshafen","Uhingen","Ulm-Erlserkirche","Ulm-Zionskirche","United Kingdom","Vaihingen/Enz","Velbert","Villingen-Schwenningen / Christuskirche","Villingen-Schwenningen / Friedenskirche","Vorpommern","Waiblingen","Waiblingen-Hegnach","Walthersdorf","Wangen / Allgu","Weilheim / Teck","Weinsberg / Neckarsulm","Weinsberg-Nackarsulm","Weissach","Weitefeld","Welzheim","Werdau","Westerstede / Wiesmoor","Westerstede/Wiesmoor","Wetzlar","Wiesbaden","Wilhelmshaven","Wilkau-Halau","Winnenden","Wismar","Wolfsburg","Wuppertal-Barmen","Wuppertal-Elberfeld","Wstenrot / Neuhtten","Wstenrot-Neuhtten","Zeitz / Weienfels","Zeltmission","Zittau","Zschopau","Zschorlau","Zweibrcken","Zwickau","Zwickau-Planitz","Zwnitz")

    def gemeindekartei_optionsfelder(self):
        temp =  {'Konferenz': ('-','OJK','NJK','SJK','ZK'),
                 'Distrikt': ('-','Berlin','Dresden','Essen','Frankfurt','Hamburg','Karlsruhe','Nrnberg','Reutlingen','Stuttgart','Zwickau'),
                 'Geschlecht': ('-','wl','ml'),
                 'Bezirk1': self.bezirke,
                 'Bezirk2': self.bezirke}
        return temp
    

class OptionenEmkAdressen_Neu(OptionenEmkAdressen):
    """Die Version fr die Emk-Adressdatei, Synago-Version. Nur wenig modifiziert."""    
    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="",tabelle="optionen"):
        OptionenEmkAdressen.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)
        self.status = {'-': {'ml': '-', 'wl': '-', 'b': ''},
                       'aoM': {'wl': 'ausserordentliches Mitglied', 'ml': 'ausserordentliches Mitglied', 'b': 'ausserordentliches Mitglied'},
                       'B': {'wl': 'Bischfin', 'ml': 'Bischof','b': 'Bischof/Bischfin'},
                       'BiR': {'wl': 'Bischfin im Ruhestand', 'ml': 'Bischof im Ruhestand','b': 'Bischof/Bischfin im Ruhestand'},
                       'Gr': {'wl': 'Gemeindereferentin', 'ml': 'Gemeindereferent','b': 'Gemeindereferent/in'},
                       'GriA': {'wl': 'Gemeindereferentin in Ausbildung', 'ml': 'Gemeindereferent in Ausbildung', 'b': 'Gemeindereferent/in in Ausbildung'},
                       'GriR': {'wl': 'Gemeindereferentin im Ruhestand', 'ml': 'Gemeindereferent im Ruhestand','b': 'Gemeindereferent/in im Ruhestand'},
                       'Gs': {'wl': 'Gemeindeschwester','ml': '-', 'b': 'Gemeindeschwester'},
                       'GsiR': {'wl': 'Gemeindeschwester im Ruhestand', 'ml': '-', 'b': 'Gemeindeschwester im Ruhestand'},
                       'L': {'wl': 'Laienmitglied', 'ml': 'Laienmitglied', 'b': 'Laienmitglied'},
                       'Lp': {'wl': 'Laienpredigerin', 'ml': 'Laienprediger', 'b': 'Laienprediger/in'},
                       'LpD': {'wl': 'Laienpredigerin mit Dienstzuweisung', 'ml': 'Laienprediger mit Dienstzuweisung', 'b': 'Laienprediger/in mit Dienstzuweisung'},
                       'MiG': {'wl': 'Mitarbeiterin im Gemeindedienst','ml': 'Mitarbeiter im Gemeindedienst', 'b': 'Mitarbeiter/in im Gemeindedienst'},
                       'P': {'wl': 'Pastorin', 'ml': 'Pastor', 'b': 'Pastor/in'},
                       'PaP': {'wl': 'Pastorin auf Probe', 'ml': 'Pastor auf Probe', 'b': 'Pastor/in auf Probe'},
                       'PiR': {'wl': 'Pastorin im Ruhestand', 'ml': 'Pastor im Ruhestand', 'b': 'Pastor/in im Ruhestand'},
                       'PiS': {'wl': 'Pastorin im Sonderdienst', 'ml': 'Pastor im Sonderdienst', 'b': 'Pastor/in im Sonderdienst'},
                       'PriR': {'wl': 'Predigerin im Ruhestand', 'ml': 'Prediger im Ruhestand', 'b': 'Prediger/in im Ruhestand'},
                       'Pt': {'wl': 'Praktikantin', 'ml': 'Praktikant', 'b': 'Praktikant/in'},
                       'St': {'wl': 'Studierende', 'ml': 'Studierender', 'b': 'Studierende/r'},
                       'Sup': {'wl': 'Superintendentin', 'ml': 'Superintendent', 'b': 'Superintendent/in'},
                       'W': {'wl': 'Witwe', 'ml': 'Witwer', 'b': 'Witwe/r'}                       }
       
        self.statusliste = ["%s: %s" % (i, self.status.get(i,"-")["b"]) for i in self.status.keys()]
        self.statusliste.sort()
        self.distrikte = {'-': "",
                          'B': 'Berlin',
                          'D': 'Dresden',
                          'E': 'Essen',
                          'F': 'Frankfurt',
                          'H': 'Hamburg',
                          'K': 'Karlsruhe',
                          'N': 'Nrnberg',
                          'R': 'Reutlingen',
                          'S': 'Stuttgart',
                          'Z': 'Zwickau'}
        self.distriktsliste = ["%s: %s" % (i, self.distrikte.get(i,"-")) for i in self.distrikte.keys()]
        self.distriktsliste.sort()

       
    def gemeindekartei_optionsfelder(self):
        temp =  {'Konferenz': ('-','OJK','NJK','SJK'),
                 'Distrikt': self.distriktsliste,
                 'Geschlecht': ('-','wl','ml'),
                 'Status1': self.statusliste,
                 'Status2': self.statusliste,
                 'Status3': self.statusliste,
                 'Status4': self.statusliste,
                 'Status5': self.statusliste}
        return temp

    

class DummyOptionen(OptionenNormal):
    """Diese Klasse wird gebraucht, um vor dem Login (also ohne Cookie
    mit Buchungsjahr und Datenbank) ein Optionen-Objekt zu erzeugen. Funktioniert mit der
    immer in Mysql eingebauten Datenbank test. Ist hier ein Sicherheitsloch?"""

    def __init__(self):
        if sys.platform[:3] == "win":
            MysqlDatenbank = MySQLdb.connect(db="test", user = "ODBC")
        else:
            MysqlDatenbank = MySQLdb.connect(db="musterkartei", host="localhost", user=verwaltungMainServer.datenbank_user, passwd=verwaltungMainServer.datenbank_passwort)
        OptionenNormal.__init__(self,MysqlDatenbank,"dummybuchungsjahr")

    def __del__(self):
        self.verbindungBeenden()
        # damit die Verbindung nicht unntig offen bleibt. Genug Sicherheit?

    def selectBefehlDirekt(self,befehl):
        # diese gefhrliche Option ist gesperrt.
        pass

def Optionen(MysqlDatenbank,buchungsjahr,datenbank="",tabelle="optionen"):
    """Eine "Factory"-Funktion, um die verschiedenen Bezirksreiter-Geschmacksrichtungen
    zu beliefern."""
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)
    if kirche == "metho":
        return OptionenNormal(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    elif kirche in ("evang","kath"):
        return OptionenEvangKath(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    elif kirche == "emkadressen":
        return OptionenEmkAdressen(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    elif kirche == "emkadressen_neu":
        return OptionenEmkAdressen_Neu(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    


  
  
   

   

