#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.

import string
# import MySQLdb
import urllib
import sys
import re
import types
import time
import os
import glob
import zipfile
import shutil

# Achtung, fr einen Server ohne Tkinter mu dieses Modul ggf. durch ein leeres
# Dummy-Modul ersetzt werden - oder Importerrors etc. anders umgangen werden.

GUI = 1
try:
   from Tkinter import *
   from SimpleDialog import SimpleDialog
except:
   GUI = 0
DEBUG = 1

class ScrolledText(Frame):    
    def __init__(self,parent=None, text="", file=None, height=10):
        Frame.__init__(self, parent)
        self.height=height
        self.pack(expand=YES, fill=BOTH)
        self.makeWidgets()
        self.settext(text, file)

    def makeWidgets(self):
        sbar = Scrollbar(self)
        text = Text(self, relief=SUNKEN, bg="white",height=self.height)
        sbar.config(command=text.yview)
        text.config(yscrollcommand=sbar.set)
        sbar.pack(side=RIGHT, fill=Y)
        text.pack(side=LEFT, expand=YES, fill=BOTH)
        self.text = text

    def settext(self, text="", file=None):
        if file:
            text = open(file,"r").read()
        self.text.delete("1.0", END)
        self.text.insert("1.0", text)
        #self.text.mark_set(INSERT, "1.0")
        #self.text.focus()

    def gettext(self):
        return self.text.get("1.0", END+"-1c")

    def write(self,text=""):
        # damit kann man stdout umlenken
        self.text.insert(END,text)
        self.text.see(END)
        self.text.update()

class ScrolledList(Frame):    
    def __init__(self, options, parent=None):        
        Frame.__init__(self, parent)
        self.pack(expand=YES, fill=BOTH)
        self.makeWidgets(options)
        self.label = ""
        self.index = 0
        self.parent = parent
        
    def handleList(self, event):
        self.index = self.listbox.curselection()
        self.label = self.listbox.get(self.index)
        self.listbox.get(self.index)
        self.runCommand()

    def makeWidgets(self, options):
        sbar = Scrollbar(self)
        list = Listbox(self, relief=SUNKEN)
        sbar.config(command=list.yview)
        list.config(yscrollcommand=sbar.set)
        sbar.pack(side=RIGHT,fill=Y)
        list.pack(side=LEFT, expand=YES, fill=X)
        pos = 0
        for label in options:
            list.insert(pos, label)
            pos += 1
            #list.config(selectmode=SINGLE, setgrid=1)
            list.bind("<Double-1>", self.handleList)
            self.listbox = list

    def runCommand(self):
        print "Sie haben gewaehlt: ", self.label

class functionalScrolledList(ScrolledList):
    # Ruft bei Doppelklick eine bergebene Funktion auf.
    # bergibt den aktuell gewhlten Index der Liste.
    # Lscht dann automatisch die Liste vom Bildschirm.
    def __init__(self,options,function,parent=None):
        self.function = function
        ScrolledList.__init__(self,options,parent)

    def runCommand(self):
        self.function(int(self.index[0]))
        # der Listenindex enthlt ein einelementiges
        # String-Tupel: Umwandlung in Integer
        self.parent.destroy()

class entryField(Frame):
    def __init__(self,feldnamen,parent=None,labellaenge=20):
        Frame.__init__(self,parent)
        #self.pack(side=LEFT,expand=YES,fill=X)
        self.felder_dict = self.felderErzeugen(feldnamen,labellaenge=labellaenge)

    def felderErzeugen(self,feldnamen,labellaenge=20):
        tempdict = {}
        for feld in feldnamen:
            Label(self,width=labellaenge,text=feld).pack(side=LEFT)
            tempentry = Entry(self)
            tempentry.pack(side=RIGHT,expand=YES,fill=X)
            var = StringVar()
            tempentry.config(textvariable=var)
            tempdict[feld] = var
        return tempdict

    def feldHolen(self,feld):
        try:
            return self.felder_dict[feld].get()
        except:
            return ""

    def feldSetzen(self,feld,wert):
        try:
            self.felder_dict[feld].set(wert)
            return 1
        except:
            return 0


class Update:
   """Das Interface fr alle Update-Klassen. Die Instanzen selbst werden von
   einer globalen Factory-Funktion UniversalUpdate systemabhngig aus den Unterklasssen erzeugt.
   Die Klasse Update kann nicht fr sich Instanzen bilden, nur die Unterklassen!"""
   def __init__(self):
      """Diese Funktion setzt voraus, da im Konstruktor der Subklasse bereits
      einige Variablen (systemspezifisch) initialisiert wurden."""
      # self.browser = {}
      # self.spacetest = re.compile(r"\\(\w*\s\w*)")
      # self.bezirksreiter_url = """http://emk-eibenstock.bei.t-online.de/Bezirksreiter"""
      # Neu:
      self.bezirksreiter_url = """http://www.bezirksreiter.de/bezirksreiter/download"""
      # *** ==> zum Testen:
      #self.bezirksreiter_url = """http://localhost:8030"""
      self.versionsinfo_alt = {}
      self.server_aus_url = """http://localhost:8000/cgi-bin/aus"""
      self.versionsinfo_datei = """versionsinfo.txt""" # Achtung, ein relativer Pfad!
      # self.hinweis_datei = """hinweise.txt"""
      self.versionsinfo_url = """%s/%s""" % (self.bezirksreiter_url, self.versionsinfo_datei)
      # self.hinweis_url = """%s/%s""" % (bezirksreiter_url, hinweis_datei)
      self.versionsinfo_update = {}
      # Enthlt die aus dem Internet geladenen Versionsinfos der neuesten Version
      self.nicht_loeschen = ["BezirksreiterStart.py", "BezirksreiterStart","passwort.py","checkin","admin_config.py"]
      # Hier befinden sich alle Dateien, die aus der alten Version nicht gelscht werden.
      self.updateDateienWeb = os.listdir(self.bezirksreiter)
      # alle Dateien, die fr das Update/Wartung-Webinterface gebraucht werden
      self.versionsinfo_pfad = os.path.normpath(os.path.join(self.bezirksreiter,self.versionsinfo_datei))
      self.musterkartei = "musterkartei"
      self.musterdump_sql = os.path.normpath(os.path.join(self.recovery,self.musterkartei_sql))
      # self.gui = GUI
      if GUI:
         self.hauptfensterErzeugen()

   def hauptfensterErzeugen(self):
      self.hauptfenster = Tk()
      self.hauptfenster.title("Bezirksreiter - Das Updateprogramm")
      self.savestream = sys.stdout
      self.tempspeicher = None
      self.obenframe = Frame(self.hauptfenster,bg="#fbffa9")
      self.obenframe.pack(side=TOP, expand=YES, fill=BOTH)
      Label(self.obenframe, text="""Technische Meldungen des Updateprogramms \nim weien Feld:\n(Fr Interessierte, zur Fehlersuche usw.)""",bg="#fbffa9").pack(side=RIGHT, expand=YES, fill=X)
      self.textfeld = ScrolledText(self.hauptfenster)
      self.fastuntenframe = Frame(self.hauptfenster)
      self.fastuntenframe.pack(side=TOP, expand=YES,fill=BOTH)
      self.untenframe = Frame(self.hauptfenster)
      self.untenframe.pack(side=TOP, expand=YES, fill=BOTH)
      self.hauptlabel = Label(self.fastuntenframe, text="",width=60,height=9,bg="#dcffcc")
      self.hauptlabel.pack(side=BOTTOM, expand=YES, fill=BOTH)
      #self.eingabe = entryField(["Eingabefeld"],self.untenframe,labellaenge=20)
      #self.eingabe.pack(side=LEFT, expand=YES, fill=X)
      self.platzhalter = Label(self.untenframe,text="",width=30)
      self.platzhalter.pack(side=LEFT, expand=YES, fill=X)
      self.ok_button = Button(self.untenframe, text="Weiter")
      self.ok_button.pack(side=LEFT, expand=YES, fill=X)
      self.no_button = Button(self.untenframe, command=self.hauptfenster.destroy,text="Abbruch")
      self.no_button.pack(side=LEFT, expand=YES, fill=X)
      sys.stdout = self.textfeld
      self.updateGui()
      self.hauptfenster.mainloop()


   def popupFehler(self,meldung="Bei der Installation des Bezirksreiters ist ein Fehler aufgetreten: \nBitte lesen Sie die Ausgabe im weien Fenster \nund beenden Sie dann das Programm!"):
      root = Toplevel(self.hauptfenster,bg="red")
      Label(root,text=meldung,bg="red").pack()
      Button(root,text="Beenden",command=self.hauptfenster.destroy,bg="green").pack()      
      root.focus_set()
      root.grab_set()
      root.mainloop()


   def untenframeWarten(self,button):
      """Ein verschachteltes Event-Loop fr die Knpfe und das Eingabefeld unten.
      Wirkt auf das umgebende Frame."""
      button.config(command=self.untenframe.quit)
      button.config(command=self.untenframe.quit)
      self.untenframe.focus_set()
      self.untenframe.grab_set()
      self.untenframe.mainloop()
      #if DEBUG:
      #   print "untenframeWarten beendet"

   def hauptlabelAusgabe(self,text):
      self.hauptlabel.config(text=text)
      self.hauptlabel.update()

   def musterkarteiEinlesen(self,u_oder_w):
      # wird nur in den Subklassen implementiert
      pass  

   def konfigurationEinlesen(self,text):
      """Parst einen Text (z.B. aus einer eingelesenen Konfigurationsdatei), gibt die Daten
      in einem Dictionary zurck. Primitiv und nicht sehr fehlertolerant. Windows-geeignet?
      (Wegen Zeilenendezeichen) => Beim Test ging es."""
      # ***** Diese Funktion ist eine (fast) exakte Kopie aus der Klasse
      # textutilities - wir wollen aber, da update.py ohne andere Module funktioniert,
      # schlielich soll es das Bezirksreiter-Verzeichnis lschen.
      alleZeilen = text.split("\n")
      datendict = {}
      for i in alleZeilen:
         try:
            if i[0] == "#":
               # Kommentarzeilen berspringen.
               continue
            i = i.rstrip()
            templist = i.split("=")
            datendict[templist[0]] = "%s" % templist[1]          
         except:
            # hier werden z.B. leere oder falsche Zeilen behandelt:
            pass
      return datendict

   def seiteLaden(self,url):
      """Ldt eine URL und gibt sie als String zurck. Setzt eine bestehende
      Internet-Verbindung voraus, sonst Abbruch und Fehlermeldung."""
      if not GUI:
         print "Lade Internetseite, bitte warten..."
      else:
         self.hauptlabelAusgabe("Lade Internetseite, bitte warten...")
      try:
         try:
            textfile = urllib.urlopen(url)
         except:
            print "Seite konnte nicht aus dem Internet geladen werden. Verbindung unterbrochen?"
            return 0
         # print text.read()
         text = textfile.read()
         textfile.close()
         fehlercheck = re.compile(r"t-online - error 404",re.IGNORECASE)
         if fehlercheck.search(text):
            print "Die Seite wurde bei T-Online nicht gefunden (Error 404). Existiert sie nicht?"
            return 0
         return text
      except:
         print "Abbruch mit Fehler!"
         return 0

   def versionsinfoHolen(self):
      tempdata = self.seiteLaden(self.versionsinfo_url)
      if not tempdata:
         print "Versionsinformation konnte nicht ermittelt werden!"
         return 0
      self.versionsinfo_update.update(self.konfigurationEinlesen(tempdata))
      if os.path.exists(self.versionsinfo_pfad):
         tempfile = open(self.versionsinfo_pfad,"r")
         tempdata = tempfile.read()
         tempfile.close()
         self.versionsinfo_alt.update(self.konfigurationEinlesen(tempdata))
      else:
         self.versionsinfo_alt = {"letztesUpdate": "0000-00-00-00-00 = unbekannt", "versionsnummer": "0000 = unbekannt","sql_einlesen": "0000", "neuinstallation": "0000","hinweise": "keine"}
      versionsdict = {"update": self.versionsinfo_update, "alt": self.versionsinfo_alt}
      return versionsdict

   def seiteSpeichern(self,datenstring,datei):
      try:            
         lokaleDatei = open(datei,"wb")
         # Binr wegen Windows
         lokaleDatei.write(datenstring)
         lokaleDatei.close()
         return 1
      except:
         print """Seite konnte nicht gespeichert werden."""
         return 0

   def verzeichnisLoeschen(self,verzeichnis):
      """Eine sichere Methode, Verzeichnisse zu lschen,
      bercksichtigt ein spez. Windows-Problem."""
      verzeichnis = os.path.normpath(verzeichnis)
      if os.path.exists(verzeichnis):
         for i in os.listdir(verzeichnis):
            datei = os.path.normpath(os.path.join(verzeichnis,i))
            os.chmod(datei,0777)
            # wichtig fr Windows(sic!)
         shutil.rmtree(verzeichnis)

   def updateverzeichnisErstellen(self,webinterface="nein",verzeichnis=None):
      if verzeichnis is None:
         verzeichnis = self.bezirksreiter
      if webinterface == "nein":
         updatedateien = ["update.py"]
      else:
         updatedateien = self.updateDateienWeb
      self.verzeichnisLoeschen(self.updateverzeichnis)
      os.mkdir(self.updateverzeichnis)
      for datei in updatedateien:
         if os.path.isfile(datei):
            shutil.copy(os.path.normpath(os.path.join(verzeichnis,datei)),self.updateverzeichnis)

   def updateverzeichnisLoeschen(self):
      if __name__ == "__main__":
         # der Skript soll sich ja nicht selbst lschen, wenn er Stand-Alone aufgerufen wird.
         return 0
      else:
         verzeichnisLoeschen(self.updateverzeichnis)
         return 1

   def imUpdateverzeichnis(self):
      """Testet, ob die Working-Directory das Updateverzeichnis ist."""
      if os.getcwd().lower() == os.path.normpath(self.updateverzeichnis).lower():
         # lower() wegen DOS-Pfad-Problemen...
         return 1
      else:
         return 0

   def bezirksreiteraltErstellen(self):
      try:
         if os.path.exists(self.bezirksreiter):
            if os.path.exists(self.recovery):
               self.verzeichnisLoeschen(self.recovery)
               # alte Backups weg
            os.mkdir(self.recovery)
            # nicht mit shutil.copytree:
            # Es sollen nur Dateien, nicht etwa das User_DirSystemVariablen-Verzeichnis kopiert werden.
            for i in os.listdir(self.bezirksreiter):
               datei = os.path.join(self.bezirksreiter,i)
               if os.path.isfile(datei):
                  # nur Dateien werden gelscht, keine Unterverzeichnisse.
                  shutil.copy(datei,self.recovery)
                  if i not in self.nicht_loeschen:
                     # nur Dateiname i, nicht der Pfad datei! Wichtig fr
                     # den Erhalt der Startdatei und der Passwortdateien.
                     os.remove(datei)
         else:
            os.mkdir(self.bezirksreiter)
         return 1
      except:
         return 0

   def bezirksreiterverzeichnisWiederherstellen(self):
      self.verzeichnisLoeschen(self.bezirksreiter)
      os.mkdir(self.bezirksreiter)
      for datei in os.listdir(self.recovery):
         shutil.copy(os.path.normpath(os.path.join(self.recovery,datei)),self.bezirksreiter)

   def serverAusschalten(self):
      """Schaltet den Bezirksreiter-Server aus."""
      try:
         urllib.urlopen(self.server_aus_url)
      except:
         pass

   def updateServerEinschalten(self):
      """Mu plattformspezifisch sein."""
      pass

   def beginnKonsole(self):
      """Mu plattformspezifisch sein."""
      pass

   def beginnGui(self,startverzeichnis):
      """Mu plattformspezifisch sein."""
      pass

   def fehlercheckBeginnKonsole(self,startverzeichnis):
      #  Im Folgenden ein Patch mit lower(), weil unter Windows os.getcwd ein
      # "groes" Laufwerk "C:" zurckgibt. Warum nur?
      if startverzeichnis.lower() == os.path.normpath(self.bezirksreiter).lower() and __name__ == "__main__":
         print """Das Update-Programm darf nicht aus dem \nBezirksreiter-Verzeichnis heraus aufgerufen werden!"""
         return 0
      if startverzeichnis.lower() == os.path.normpath(self.tempinstall).lower() and name == "__main__":
         print """Das Update-Programm darf nicht aus \n%s heraus aufgerufen werden!""" % self.tempinstall
         return 0
      self.verzeichnisLoeschen(self.tempinstall)
      if startverzeichnis.lower() != os.path.normpath(self.updateverzeichnis).lower() and __name__ == "__main__":
         # Bin ich nicht im Update-Verzeichnis? Dann =>
         return 0
      return 1

   def fehlercheckBeginnGui(self,startverzeichnis):
      #  Im Folgenden ein Patch mit lower(), weil unter Windows os.getcwd ein
      # "groes" Laufwerk "C:" zurckgibt. Warum nur?
      if startverzeichnis.lower() == os.path.normpath(self.bezirksreiter).lower() and __name__ == "__main__":
         self.popupFehler("""Das Update-Programm darf nicht aus dem \nBezirksreiter-Verzeichnis heraus aufgerufen werden!""")
         return 0
      if startverzeichnis.lower() == os.path.normpath(self.tempinstall).lower() and name == "__main__":
         self.popupFehler("""Das Update-Programm darf nicht aus \n%s heraus aufgerufen werden!""" % self.tempinstall)
         return 0
      self.verzeichnisLoeschen(self.tempinstall)
      if startverzeichnis.lower() != os.path.normpath(self.updateverzeichnis).lower() and __name__ == "__main__":
         # Bin ich nicht im Update-Verzeichnis? Dann =>
         return 0
      return 1

   def wiederherstellenDateienKonsole(self):
      fehlercheck = 1   
      if not os.path.exists(os.path.normpath(os.path.join(self.recovery,"bezirksreiter.htm"))):
         # eine Testdatei, die es auch schon in alten Versionen gibt...
         print "Ihr Verzeichnis mit der alten Bezirksreiter-Version existiert nicht oder ist unvollstaendig - Abbruch!"
         return 0
      ##temp = raw_input("Wollen Sie wirklich die alte Bezirksreiter-Version wiederherstellen? Die neue Version und die neue Datenbank \"musterkartei\" werden dabei ueberschrieben! \n(j/n) eingeben: ")
      temp = raw_input("Wollen Sie wirklich die alte Bezirksreiter-Version wiederherstellen? Die neue Version wird dabei ueberschrieben! \n(j/n) eingeben: ")
      if temp not in "Jj":
         print "Abbruch! "
         fehlercheck = 0
      if fehlercheck:
         self.bezirksreiterverzeichnisWiederherstellen()
      else:
         print "Keine Wiederherstellung durchgefuehrt!"
      return fehlercheck
   
   def wiederherstellenDateienGui(self):
      fehlercheck = 1   
      if not os.path.exists(os.path.normpath(os.path.join(self.recovery,"bezirksreiter.htm"))):
         # eine Testdatei, die es auch schon in alten Versionen gibt...
         self.popupFehler("Ihr Verzeichnis mit der alten Bezirksreiter-Version \nexistiert nicht oder ist unvollstndig - Abbruch!")
      self.hauptlabelAusgabe("Wollen Sie wirklich die alte Bezirksreiter-Version \nwiederherstellen? Die neue Version wird dabei \nberschrieben!")
      self.untenframeWarten(self.ok_button)
      self.bezirksreiterverzeichnisWiederherstellen()
      return fehlercheck
   

   def grundoptionenPruefenKonsole(self):
      altoderneu = raw_input("Wollen Sie (u)pdaten oder (w)iederherstellen? \nBuchstabe und Eingabetaste fuer weiter: ")
      print "\n"
      if altoderneu not in "uw":
         print "Ungueltige Option!"
         altoderneu = None
     ## if altoderneu == "w":
##         # Wiederherstellen des alten Bezirksreiter-Verzeichnsses
##         if not self.wiederherstellenDateienKonsole():
##            altoderneu = None
      return altoderneu

   def grundoptionenPruefenGui(self):
      rueckgabe = {0: "u", 1: "w"}
      # Kompatibilitt mit dem Konsolenupdate
      d = SimpleDialog(self.hauptfenster,"Wollen Sie den Bezirksreiter \naus dem Internet updaten\noder eine alte \nVersion wiederherstellen?",buttons=["Update","Wiederherstellen"],title="Eingabe")
      temp = rueckgabe[d.go()]
      return temp
   
   def neueVersionLaden(self): 
      # startverzeichnis = os.getcwd()
      fehlercheck = 1
      if not self.versionsinfoHolen():
         if not GUI:
            print "Abbruch - Versionsinformation kann nicht aus dem Internet geladen werden!"
            return 0   # Funktion bricht hier ab
         else:
            self.popupFehler("Abbruch - Versionsinformation kann nicht aus dem Internet geladen werden!\nInternetverbindung ausgeschaltet/gestrt?")
      version = """Bezirksreiter%s.zip""" % self.versionsinfo_update["versionsnummer"]
      print "neuinst: ", self.versionsinfo_update["neuinstallation"], "alt: ", self.versionsinfo_alt["versionsnummer"]
      try:
         if self.versionsinfo_update["neuinstallation"] >= self.versionsinfo_alt["versionsnummer"]:
            # falls eine Neuinstallation erforderlich, wird die neueste Version des Installations
            # programms geladen:
            # os.chdir(self.updateverzeichnis)
            tempseite = self.seiteLaden("""%s/%s""" % (self.bezirksreiter_url,version))
            self.seiteSpeichern(tempseite,os.path.join(self.updateverzeichnis,version))
            tempseite = self.seiteLaden("""%s/%s""" % (self.bezirksreiter_url,"install.py"))
            self.seiteSpeichern(tempseite,os.path.join(self.updateverzeichnis,"install.py"))
            print """Die Versionskontrolle zeigt an, dass zum korrekten Update"""
            print """eine Neuinstallation der Bezirksreiter-Dateien noetig ist."""
            print """Die dazu notwendigen Dateien wurden aus dem Internet geladen."""
            print """Starten Sie nun \"install.py\" aus dem Verzeichnis %s %s.""" % (self.updateverzeichnis,self.startmethode.replace("update","install"))
            # replace um den Benutzer nicht zu verwirren...
            fehlercheck = 0
         else:
            self.seiteSpeichern(self.seiteLaden("""%s/%s""" % (self.bezirksreiter_url,version)),version)
      except:
         print "Neue Bezirksreiter-Version konnte nicht geladen werden. \nInternet-Probleme? "
         fehlercheck = 0
      # os.chdir(startverzeichnis)
      return fehlercheck

   def zipfileAuspacken(self,zipdatei,zielverzeichnis):
      try:
         z = zipfile.ZipFile(zipdatei,"r")
      except:
         print "Kann Datei %s nicht lesen! Korruptes Zip-File? " % zipdatei
         return 0 # Abbruch der Funktion
      alle = z.namelist()
      for i in alle:
         # Auspacken ...
         try:
            dname = os.path.join(zielverzeichnis,i)
            datei = open (dname,"wb")
            # Achtung, Binrdatei, z.B. circut5.jpg. Fr Windows deshalb ffnen im Binrmodus!
            datei.write(z.read(i))
            datei.close()
         except:
            print "Fehler beim Auspacken der Datei %s! " % zipdatei
            return 0 # Abbruch der Funktion 
      z.close()
      # Achtung, zipfile-Objekt schlieen - fr Windows, damit nichts schiefgeht.
      # Unter Unix lassen sich spter auch offene Dateien lschen.
      return 1

   def updateInstallieren(self):
      """Installiert das Update aus der geladenen Zip-Datei in self.updateverzeichnis, sichert alte Version."""
      try:
         alle = glob.glob(os.path.join(self.updateverzeichnis,"Bezirksreiter*.zip"))
         neueversion = os.path.join(self.updateverzeichnis,os.path.basename(max(alle)))
         # der komplette Pfad der Bezirksreiter-Datei mit der hchsten Versionsnummer.
      except:
         if not GUI:
            print "\nKeine Installationsdatei Bezirksreiterxxxx.zip vorhanden!"
            return 0 # Abbruch der Funktion
         else:
            self.popupFehler("Keine Installationsdatei Bezirksreiterxxxx.zip vorhanden!")
      # **** Ggf. Sichern einer alten Version, lschen der Dateien (nicht: UserVerzeichnisse usw.) des
      # **** Bezirksreiter-Verzeichnisses:
      if not self.bezirksreiteraltErstellen():
         if not GUI:
            print "Die alte Version konnte nicht gesichert werden. Abbruch!"
            return 0 # Abbruch der Funktion
         else:
            self.popupFehler("Die alte Version konnte nicht gesichert werden. Abbruch!")
      if not self.zipfileAuspacken(neueversion,self.bezirksreiter):
         self.bezirksreiterverzeichnisWiederherstellen()
         if not GUI:
            print "Kein Update durchgefuehrt. Die alte Version wurde wiederhergestellt."
            return 0 # Abbruch der Funktion
         else:
            self.popupFehler("Kein Update durchgefhrt. Die alte Version wurde wiederhergestellt.")
      return 1

   def vorlagenInstallieren(self):
      if not os.path.exists(self.neue_vorlagenverzeichnis):
         os.mkdir(self.neue_vorlagenverzeichnis)
      alle = glob.glob(os.path.normpath(os.path.join(self.bezirksreiter,"*.rtf")))
      sxw = glob.glob(os.path.normpath(os.path.join(self.bezirksreiter,"*.sxw")))
      alle = alle + sxw
      # RTF- und OpenOffice-Writer-Vorlagen.
      #print alle
      try:
         for vorlage in alle:
            print "Vorlage %s" % vorlage
            ziel = os.path.normpath(os.path.join(self.neue_vorlagenverzeichnis,os.path.basename(vorlage)))
            shutil.copyfile(vorlage,ziel)
         for vorlage in alle:
            os.chmod(vorlage,0777)
            # hier noch time.sleep()?
            os.remove(vorlage)
         return 1
      except:
         print "Vorlagen konnten nicht installiert werden."
         return 0

   def stringErsetzenDatei(self,datei,stringalt,stringneu):     
      try:
         os.chmod(datei,0777)
         f = open(datei,"rb")   
         inhalt = f.read()
         f.close()
         inhalt = string.replace(inhalt,stringalt,stringneu)
         os.chmod(datei,0777)
         time.sleep(1)
         # fr Windows
         f = open(datei,"wb")
         f.write(inhalt)
         f.close()
         return 1
      except:
         return 0

   def updateKonsole(self):
      """Dies ist die Hauptfunktion, die aufgerufen wird,
      wenn das Programm stand-alone von der Konsole ausgefhrt wird.."""
      # *** Achtung, das Neueinlesen der musterkartei wurde abgestellt *** !!!
      startverzeichnis = os.path.normpath(os.getcwd())
      if not self.beginnKonsole(startverzeichnis):
         # wird der Skript aus dem falschen Verzeichnis heraus aufgerufen? =>
         return 0   
      # Achtung: Wegen Folgendem mu der Update-Skript update.py in einem anderen Verzeichnis stehen,
      # das wird in beginnKonsole() geprft:
      # os.mkdir(self.tempinstall)
      # os.chdir(self.tempinstall)
      # => tempinstall erzeugen.
      # Dann zuerst den Bezirksreiter-Server ausschalten: 
      print "Bitte warten... Bei \"Haengen\" Ctrl-C fuer weiter!"
      self.serverAusschalten()
      temp = raw_input("Der Bezirksreiter-Server ist jetzt ausgeschaltet. Eingabetaste fuer weiter: ")
      u_oder_w = self.grundoptionenPruefenKonsole() # (u)pdaten oder (w)iederherstellen?
      if not u_oder_w:
         return 0
      # *** Achtung, das Folgende nur bei Wiederherstellen: **********************:
      if u_oder_w == "w":
         if not self.wiederherstellenDateienKonsole():
            return 0 # Abbruch der Funktion
         # if not self.musterkarteiEinlesen(u_oder_w):
         #   return 0
         # ******* Wird abgeschaltet *********
         # print """Alte Version wiederhergestellt, einschliesslich Datenbank \"musterkartei\" !"""
         print """Alte Version wiederhergestellt!"""
      # *** Achtung, das Folgende nur bei Update *********************************:
      if u_oder_w == "u":
         if not self.neueVersionLaden():
            return 0
         temp = raw_input("\nAlle noetigen Dateien geladen. Update jetzt durchfuehren? \nAlte Version wird gesichert in\n%s \nEingabe: j/n: " % (self.recovery))
         if temp not in "Jj":
            print "\nUpdate abgebrochen!"
            return 0
         if not self.updateInstallieren():
            return 0
         self.vorlagenInstallieren()
         # ***** Ggf. Neueinlesen der "musterkartei"-Datenbank: *******************
        ## if self.versionsinfo_update["musterkartei_einlesen"] >= self.versionsinfo_alt["versionsnummer"]:
##            temp = raw_input("""Die Versionskontrolle empfiehlt ein neues Einlesen von Datenbank \"musterkartei\". Dabei werden alle Daten in dieser Datenbank geloescht. Einlesen (j/n) ?""")
##            if temp not in "Jj":
##               print "Die neue Datenbank \"musterkartei\" wurde nicht eingelesen!!"
##               # os.chdir(startverzeichnis)
##               # self.verzeichnisLoeschen(self.tempinstall)
##               return 1 # Ende von updateKonsole
##            else:
##               # *** Hier mu das Neueinlesen der Musterkartei stehen!!! ********
##               if not self.musterkarteiEinlesen(u_oder_w):
##                  print "Ende des Update-Programmes, ohne Einlesen von." % self.musterkartei
##                  # os.chdir(startverzeichnis)  # warum?
##                  self.verzeichnisloeschen(self.tempinstall)
##                  return 0
##               else:
##                  print "Datenbank %s wurde neu eingelesen." % self.musterkartei
##         else:
##            print "Update fertig. Die Datenbank \"musterkartei\" wurde dabei neu nicht eingelesen!"
         print "Update fertig."
         #    return 1 # Ende von updateKonsole
      # ****** Ende des Update-Abschnittes **********
      return 1
   

   def updateGui(self):
      """Dies ist die Hauptfunktion, die aufgerufen wird,
      wenn das Programm stand-alone als GUI-Anwendung ausgefhrt wird.."""
      # *** Achtung, das Neueinlesen der musterkartei wurde abgestellt *** !!!
      startverzeichnis = os.path.normpath(os.getcwd())
      self.beginnGui(startverzeichnis)
      # Achtung: Wegen Folgendem mu der Update-Skript update.py in einem anderen Verzeichnis stehen,
      # das wird in beginnGui() geprft:
      # os.mkdir(self.tempinstall)
      # os.chdir(self.tempinstall)
      # => tempinstall erzeugen.
      u_oder_w = self.grundoptionenPruefenGui() # (u)pdaten oder (w)iederherstellen?
      # Dann zuerst den Bezirksreiter-Server ausschalten: 
      # print "Bitte warten... Bei \"Haengen\" Ctrl-C fuer weiter!"
      self.serverAusschalten()
      self.hauptlabelAusgabe("Der Bezirksreiter-Server ist jetzt ausgeschaltet. Weiter?")
      self.untenframeWarten(self.ok_button)
      if not u_oder_w:
         return 0
      # *** Achtung, das Folgende nur bei Wiederherstellen: **********************:
      if u_oder_w == "w":
         self.wiederherstellenDateienGui()
         # self.musterkarteiEinlesen(u_oder_w)
         # ******** Wird abgeschaltet ****************
         # print """Alte Version wiederhergestellt, einschliesslich Datenbank \"musterkartei\" !"""
         self.hauptlabelAusgabe("""Alte Version wiederhergestellt!""")
         self.ok_button.config(text="Beenden")
         self.untenframeWarten(self.ok_button)
         self.hauptfenster.destroy
         sys.exit()  # Abbruch
      # *** Achtung, das Folgende nur bei Update *********************************:
      if u_oder_w == "u":
         self.neueVersionLaden()
         self.hauptlabelAusgabe("Alle ntigen Dateien geladen. Update jetzt durchfhren? \nAlte Version wird gesichert in\n%s." % self.recovery)
         self.untenframeWarten(self.ok_button)
         
         self.updateInstallieren()
         zusatz = "Die neuen Vorlagen \nbefinden sich im Verzeichnis \n%s\nBitte mit Ihrer Textverarbeitung anschauen und \nggf. in ihr Vorlagenverzeichnis kopieren." % self.neue_vorlagenverzeichnis
         if not self.vorlagenInstallieren():
            zusatz = "Die neuen Vorlagen konnten nicht installiert werden."
         self.hauptlabelAusgabe("Update fertig. %s" % zusatz)
         #    return 1 # Ende von updateKonsole
         self.ok_button.config(text="Beenden")
         self.untenframeWarten(self.ok_button)
         self.verzeichnisLoeschen(self.updateverzeichnis)
         # aufrumen...
         self.hauptfenster.destroy()
         sys.exit()
      # ****** Ende des Update-Abschnittes **********


class LinuxUpdate(Update):
   """Plattformspezifische Implementierung der Klasse Update."""
   def __init__(self):
      self.bezirksreiter = os.path.join(os.environ["HOME"],"Bezirksreiter/Bezirksreiter")
      self.recovery = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterAlt")
      self.tempinstall = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterInstall")
      self.updateverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterUpdate")
      self.startmethode = "von einer Konsole mit dem Befehl \"python ./update.py\" "
      self.sicherungsverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterSicherung")
      self.vorlagenverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterVorlagen")
      self.neue_vorlagenverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterNeueVorlagen")
      self.musterkartei_sql = "musterlin.sql"
      Update.__init__(self)

   def bezirksreiterverzeichnisWiederherstellen(self):
      Update.bezirksreiterverzeichnisWiederherstellen(self)
      os.system("chmod a+x %s" % os.path.join(self.bezirksreiter,"BezirksreiterStart"))
      # Startdatei ausfhrbar machen

   def updateServerEinschalten(self,startverz):
      """Schaltet den Server fr das Webinterface ein."""
      # os.chdir("%s" % self.updateverzeichnis)
      # cgiserver mu aus dem gleichen Verzeichnis gestartet werden, oder?
      pfad = os.path.normpath(os.path.join(self.updateverzeichnis,"cgiserver_update.py"))
      print os.spawnlp(os.P_NOWAIT,"python","python",pfad)
      # test!
      print "hier"
      # os.chdir(startverz)

   def beginnKonsole(self,startverzeichnis):
      fehlercheck = 1
      print "\n\n===============>"
      temp = raw_input("Dieses Programm dient zum automatischen Internet-Update fuer den \"Bezirksreiter\". Es dient auch zum Wiederherstellen einer alten Version aus dem Verzeichnis %s.\nInternetverbindung hergestellt (bei Update)? Browser weggeklickt? Dann Eingabetaste fuer weiter: " % self.recovery)
      temp = raw_input("Achtung: Dieses Konsolen-Fenster sollte nach dem Beenden aller Update- bzw. Installationsvorgaenge manuell weggeklickt werden. Der Neustart des Bezirksreiters ist sonst ggf. blockiert. Eingabetaste fuer weiter: ")
      fehlercheck = self.fehlercheckBeginnKonsole(startverzeichnis)      
      if not fehlercheck:
         self.updateverzeichnisErstellen(startverzeichnis)
         # Von hier aus soll es dann noch einmal gestartet werden.
         print """\nAchtung: Starten Sie update.py noch einmal aus dem Verzeichnis \n %s\nvon einer Konsole!""" % self.updateverzeichnis
      return fehlercheck

   def beginnGui(self,startverzeichnis):
      fehlercheck = 1
      self.hauptlabelAusgabe("""Dieses Programm dient zum automatischen \nInternet-Update fr den \"Bezirksreiter\". Es dient auch \nzum Wiederherstellen einer alten Version aus dem Verzeichnis \n"%s".\nInternetverbindung hergestellt (bei Update)? \nBrowser weggeklickt? Dann "Weiter": """ % self.recovery)
      self.untenframeWarten(self.ok_button)
      fehlercheck = self.fehlercheckBeginnGui(startverzeichnis)      
      if not fehlercheck:
         self.updateverzeichnisErstellen(startverzeichnis)
         # Von hier aus soll es dann noch einmal gestartet werden.
         self.popupFehler("""\nAchtung: Starten Sie update.py noch einmal aus dem Verzeichnis \n %s!""" % self.updateverzeichnis)
      return fehlercheck

   def musterkarteiEinlesen(self,u_oder_w):
      if u_oder_w == "u":
         musterkarteipfad = os.path.normpath(os.path.join(self.bezirksreiter,self.musterkartei_sql))
      elif u_oder_w == "w":
         musterkarteipfad = os.path.normpath(os.path.join(self.recovery,self.musterkartei_sql))
      if not self.stringErsetzenDatei(musterkarteipfad,"heimatverzeichnis",os.environ["HOME"]):
         # fr Linux mu unter "Optionen" das Heimatverzeichnis explizit angegeben werden,
         # nur ~/BezirksreiterSicherung usw. funktioniert nicht.
         print "%s konnte nicht korrekt verarbeitet werden. Einlesen der Datenbank %s abbgebrochen!" % (self.musterkartei_sql,self.musterkartei)
         return 0
      try:
         if u_oder_w == "u":
            # fr das Update: 
            os.system("mysqldump --add-drop-table %s > %s" % (self.musterkartei,self.musterdump_sql))
            os.system("mysql < %s" % self.musterkartei)
         elif u_oder_w == "w":
            os.system("mysql %s < %s" % (self.musterkartei,musterkarteipfad))
         return 1
      except:
         print """\nKonnte den Mysql-Server nicht erreichen! "mysld" aufrufen (ggf. als "root") !"""
         return 0


class WindowsUpdate(Update):
   """Plattformspezifische Implementierung der Klasse Update."""
   def __init__(self):      
      self.bezirksreiter = """c:/Bezirksreiter/Bezirksreiter"""
      self.recovery = """c:/Bezirksreiter/BezirksreiterAlt"""
      self.tempinstall = """c:/Bezirksreiter/BezirksreiterInstall"""
      self.updateverzeichnis = """c:/Bezirksreiter/BezirksreiterUpdate"""
      self.startmethode = "durch Doppelklicken im Explorer. Achtung: Bei manchen Explorer-Einstellungen fehlt die Endung \".py\"!"
      self.sicherungsverzeichnis = """c:/Bezirksreiter/BezirksreiterSicherung"""
      self.vorlagenverzeichnis = """c:/Bezirksreiter/BezirksreiterVorlagen"""
      self.neue_vorlagenverzeichnis = """c:/Bezirksreiter/BezirksreiterNeueVorlagen"""
      self.musterkartei_sql = "musterwin.sql"
      self.mysql_pfad = "c:/mysql/bin"
      # Achtung, dieser Pfad ist (fr Windows-NT-Systeme?) ggf. anzupassen -
      # vgl. dazu auch den Eintrag "Datenbankverzeichnis" in der Tabelle optionenxxxx.
      self.mysqld = os.path.normpath(os.path.join(self.mysql_pfad,"mysqld.exe"))
      self.mysql = os.path.normpath(os.path.join(self.mysql_pfad,"mysql.exe"))
      self.mysqldump =  os.path.normpath(os.path.join(self.mysql_pfad,"mysqldump.exe"))
      Update.__init__(self)

   def beginnGui(self,startverzeichnis):
      fehlercheck = 1
      self.hauptlabelAusgabe("""Dieses Programm dient zum automatischen \nInternet-Update fr den \"Bezirksreiter\". Es dient auch \nzum Wiederherstellen einer alten Version aus dem Verzeichnis \n"%s".\nInternetverbindung hergestellt (bei Update)? \nBrowser weggeklickt? Dann "Weiter": """ % self.recovery)
      self.untenframeWarten(self.ok_button)
      fehlercheck = self.fehlercheckBeginnGui(startverzeichnis)
      if not fehlercheck:
         self.updateverzeichnisErstellen(startverzeichnis)
         # Von hier aus soll es dann noch einmal gestartet werden.
         zusatz = "\nAchtung: Im Windows-Explorer wird u.U. nicht \nsofort das u.g. Update-Verzeichnis angezeigt. Dazu ggf. den Verzeichnisbaum ein- und ausklappen, \noder den Explorer noch einmal starten, \noder das rechte Fenster des Explorers benutzen."
         self.popupFehler("""\nAchtung: Starten Sie update.py noch einmal aus dem Verzeichnis \n %s\n%s! %s """ % (self.updateverzeichnis,self.startmethode,zusatz))
      return fehlercheck

   def updateServerEinschalten(self):
      """Schaltet den Server fr das Webinterface ein."""
      # ********** Achtung, Test-Patch! s.u. ***************
      pass
     ## startverz = os.getcwd()
##      os.chdir("%s" % self.updateverzeichnis)
##      os.system("""start %s""" % os.path.normpath(os.path.join(self.updateverzeichnis,"cgiserver_update.py")))
##      os.chdir(startverz)

   def musterkarteiEinlesen(self,u_oder_w):
      # *** Achtung, Test-Patch, damit auch auf NT / XP lauffhig. *********
      if DEBUG:
         print "Bei dieser Update-Funktion wird die musterkartei\n z.Zt. nicht wiederhergestellt!"
      return 1
      ##if u_oder_w == "u":
##         musterkarteipfad = os.path.normpath(os.path.join(self.bezirksreiter,self.musterkartei_sql))
##      elif u_oder_w == "w":
##         musterkarteipfad = os.path.normpath(os.path.join(self.recovery,self.musterkartei_sql))
##      if not os.path.exists(self.mysql):
##         print """Pfad fr Mysql-Datenbank nicht gefunden unter % !""" % self.mysql
##         print """ggf. ist ein Patch durchzufuehren: Modul update.py, class WindowsUpdate, __init__(), self.mysql_pfad = ..."""
##         print """oder E-Mail an me.simon@t-online.de."""
##         return 0 # Abbruch der Funktion
##      try:
##         os.system("start %s" % self.mysqld)
##      except:
##         # wenn der Server schon luft usw.
##         pass
##      if u_oder_w == "u":
##         try:
##            os.system("start %s --add-drop-table %s > %s" % (self.mysqldump,self.musterkartei,self.musterdump_sql))
##            # ggf. Sichern der alten Musterdatenbank
##         except:
##            pass
##      # Und jetzt das Einlesen:
##      if u_oder_w == "u":
##         befehl = """start %s < %s """ % (self.mysql,musterkarteipfad)
##      elif u_oder_w == "w":
##         befehl = """start %s %s < %s """ % (self.mysql,self.musterkartei,musterkarteipfad)
##         # beim Wiederherstellen wird in eine existierende Datenbank eingelesen,
##         # die Sicherungen enthalten keine "drop database"-Befehle.
##      test = os.system(befehl)
##      # Einlesen der Musterdatenbank bzw. Wiederherstellen:
##      if test:
##         # etwas schiefgelaufen? =>
##         if u_oder_w == "u":
##            print "Achtung, Musterdatenbank konnte nicht neu eingelesen werden!"
##            return 0 # Abbruch
##         else:
##            print "Achtung, Musterdatenbank konnte nicht wiederhergestellt werden!"
##            return 0 # Abbruch
##      else:
##         return 1




# Globale Modul-Funktion als "Factory":
def UniversalUpdate(gui=0):
   global GUI
   if __name__ != "__main__":
      GUI = gui
      # Wenn als Objekt, dann standardmig ohne GUI!
      # z.B. wenn man ein "updatewerkzeug" braucht.
   if sys.platform[:3] == "win":
      return WindowsUpdate()         
   else:
      return LinuxUpdate()
      



if __name__ == "__main__":
   # Wenn als eigener Skript, nicht als Unterprogramm:
   up = UniversalUpdate()
   if not GUI:
      up.updateKonsole()
      temp = raw_input("Eingabetaste zum Beenden: ")






